/* Application.c generated by valac 0.44.2, the Vala compiler
 * generated from Application.vala, do not modify */

/*
* Copyright (c) 2011-2017 elementary LLC (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA.
*
* Authored by: Avi Romanoff <avi@romanoff.me>
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <clutter-gtk/clutter-gtk.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include "switchboard.h"
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <gio/gdesktopappinfo.h>

#define SWITCHBOARD_TYPE_SWITCHBOARD_APP (switchboard_switchboard_app_get_type ())
#define SWITCHBOARD_SWITCHBOARD_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp))
#define SWITCHBOARD_SWITCHBOARD_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardAppClass))
#define SWITCHBOARD_IS_SWITCHBOARD_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_SWITCHBOARD_APP))
#define SWITCHBOARD_IS_SWITCHBOARD_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_SWITCHBOARD_APP))
#define SWITCHBOARD_SWITCHBOARD_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardAppClass))

typedef struct _SwitchboardSwitchboardApp SwitchboardSwitchboardApp;
typedef struct _SwitchboardSwitchboardAppClass SwitchboardSwitchboardAppClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _SwitchboardSwitchboardAppPrivate SwitchboardSwitchboardAppPrivate;

#define SWITCHBOARD_TYPE_CATEGORY_VIEW (switchboard_category_view_get_type ())
#define SWITCHBOARD_CATEGORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SWITCHBOARD_TYPE_CATEGORY_VIEW, SwitchboardCategoryView))
#define SWITCHBOARD_CATEGORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SWITCHBOARD_TYPE_CATEGORY_VIEW, SwitchboardCategoryViewClass))
#define SWITCHBOARD_IS_CATEGORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SWITCHBOARD_TYPE_CATEGORY_VIEW))
#define SWITCHBOARD_IS_CATEGORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SWITCHBOARD_TYPE_CATEGORY_VIEW))
#define SWITCHBOARD_CATEGORY_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SWITCHBOARD_TYPE_CATEGORY_VIEW, SwitchboardCategoryViewClass))

typedef struct _SwitchboardCategoryView SwitchboardCategoryView;
typedef struct _SwitchboardCategoryViewClass SwitchboardCategoryViewClass;
enum  {
	SWITCHBOARD_SWITCHBOARD_APP_0_PROPERTY,
	SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY,
	SWITCHBOARD_SWITCHBOARD_APP_NUM_PROPERTIES
};
static GParamSpec* switchboard_switchboard_app_properties[SWITCHBOARD_SWITCHBOARD_APP_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block1Data Block1Data;

#define SWITCHBOARD_TYPE_SEARCH_ENTRY (switchboard_search_entry_get_type ())
typedef struct _SwitchboardSearchEntry SwitchboardSearchEntry;
#define _switchboard_search_entry_free0(var) ((var == NULL) ? NULL : (var = (switchboard_search_entry_free (var), NULL)))
typedef struct _Block2Data Block2Data;

struct _SwitchboardSwitchboardApp {
	GtkApplication parent_instance;
	SwitchboardSwitchboardAppPrivate * priv;
	SwitchboardCategoryView* category_view;
	GeeArrayList* previous_plugs;
	SwitchboardPlug* current_plug;
};

struct _SwitchboardSwitchboardAppClass {
	GtkApplicationClass parent_class;
};

struct _SwitchboardSwitchboardAppPrivate {
	GtkWindow* main_window;
	GtkScrolledWindow* category_scrolled;
	GtkStack* stack;
	GtkHeaderBar* headerbar;
	GraniteWidgetsAlertView* alert_view;
	GtkButton* navigation_button;
	GeeLinkedList* loaded_plugs;
	gchar* all_settings_label;
	guint configure_id;
	GtkSearchEntry* _search_box;
};

struct _Block1Data {
	int _ref_count_;
	SwitchboardSwitchboardApp* self;
	SwitchboardPlug* plug;
};

struct _SwitchboardSearchEntry {
	gchar* plug_name;
	gchar* ui_elements;
	gchar* open_window;
};

struct _Block2Data {
	int _ref_count_;
	SwitchboardSwitchboardApp* self;
	GtkAllocation rect;
	GSettings* settings;
};

static gint SwitchboardSwitchboardApp_private_offset;
static gpointer switchboard_switchboard_app_parent_class = NULL;
static gchar* switchboard_switchboard_app_plug_to_open;
static gchar* switchboard_switchboard_app_plug_to_open = NULL;
static gchar* switchboard_switchboard_app_open_window;
static gchar* switchboard_switchboard_app_open_window = NULL;
static gchar* switchboard_switchboard_app_link;
static gchar* switchboard_switchboard_app_link = NULL;
static gboolean switchboard_switchboard_app_opened_directly;
static gboolean switchboard_switchboard_app_opened_directly = FALSE;
static gboolean switchboard_switchboard_app_should_animate_next_transition;
static gboolean switchboard_switchboard_app_should_animate_next_transition = TRUE;
static SwitchboardSwitchboardApp* switchboard_switchboard_app__instance;
static SwitchboardSwitchboardApp* switchboard_switchboard_app__instance = NULL;

gint switchboard_main (gchar** args,
                       gint args_length1);
GType switchboard_switchboard_app_get_type (void) G_GNUC_CONST;
SwitchboardSwitchboardApp* switchboard_switchboard_app_get_instance (void);
GType switchboard_category_view_get_type (void) G_GNUC_CONST;
static void switchboard_switchboard_app_real_open (GApplication* base,
                                            GFile** files,
                                            gint files_length1,
                                            const gchar* hint);
static gchar* switchboard_switchboard_app_gcc_to_switchboard_code_name (SwitchboardSwitchboardApp* self,
                                                                 const gchar* gcc_name);
static void switchboard_switchboard_app_real_activate (GApplication* base);
static gboolean switchboard_switchboard_app_load_setting_path (SwitchboardSwitchboardApp* self,
                                                        const gchar* setting_path,
                                                        SwitchboardPlugsManager* plugsmanager);
void switchboard_switchboard_app_load_plug (SwitchboardSwitchboardApp* self,
                                            SwitchboardPlug* plug);
static void switchboard_switchboard_app_build (SwitchboardSwitchboardApp* self);
void switchboard_switchboard_app_hide_alert (SwitchboardSwitchboardApp* self);
void switchboard_switchboard_app_show_alert (SwitchboardSwitchboardApp* self,
                                             const gchar* primary_text,
                                             const gchar* secondary_text,
                                             const gchar* icon_name);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda6_ (Block1Data* _data1_);
GType switchboard_search_entry_get_type (void) G_GNUC_CONST;
SwitchboardSearchEntry* switchboard_search_entry_dup (const SwitchboardSearchEntry* self);
void switchboard_search_entry_free (SwitchboardSearchEntry* self);
void switchboard_search_entry_copy (const SwitchboardSearchEntry* self,
                                    SwitchboardSearchEntry* dest);
void switchboard_search_entry_destroy (SwitchboardSearchEntry* self);
GeeArrayList* switchboard_category_view_get_plug_search_result (SwitchboardCategoryView* self);
static gboolean __lambda7_ (Block1Data* _data1_,
                     SwitchboardSearchEntry* entry);
static gboolean ___lambda7__gee_forall_func (gpointer g,
                                      gpointer self);
static void switchboard_switchboard_app_switch_to_plug (SwitchboardSwitchboardApp* self,
                                                 SwitchboardPlug* plug);
static gboolean ___lambda6__gsource_func (gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void switchboard_switchboard_app_set_search_box (SwitchboardSwitchboardApp* self,
                                                 GtkSearchEntry* value);
GtkSearchEntry* switchboard_switchboard_app_get_search_box (SwitchboardSwitchboardApp* self);
SwitchboardCategoryView* switchboard_category_view_new (const gchar* plug);
SwitchboardCategoryView* switchboard_category_view_construct (GType object_type,
                                                              const gchar* plug);
static void __lambda12_ (SwitchboardSwitchboardApp* self,
                  SwitchboardPlug* plug);
static void ___lambda12__switchboard_category_view_plug_selected (SwitchboardCategoryView* _sender,
                                                           SwitchboardPlug* plug,
                                                           gpointer self);
void switchboard_category_view_load_default_plugs (SwitchboardCategoryView* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
void switchboard_category_view_load_default_plugs_finish (SwitchboardCategoryView* self,
                                                          GAsyncResult* _res_);
static void __lambda13_ (SwitchboardSwitchboardApp* self);
void switchboard_category_view_filter_plugs (SwitchboardCategoryView* self,
                                             const gchar* filter);
static void ___lambda13__gtk_editable_changed (GtkEditable* _sender,
                                        gpointer self);
static gboolean __lambda14_ (SwitchboardSwitchboardApp* self,
                      GdkEventKey* event);
void switchboard_category_view_activate_first_item (SwitchboardCategoryView* self);
static gboolean ___lambda14__gtk_widget_key_press_event (GtkWidget* _sender,
                                                  GdkEventKey* event,
                                                  gpointer self);
static void __lambda15_ (SwitchboardSwitchboardApp* self);
static void switchboard_switchboard_app_handle_navigation_button_clicked (SwitchboardSwitchboardApp* self);
static void ___lambda15__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
static void __lambda16_ (SwitchboardSwitchboardApp* self);
static void ___lambda16__g_simple_action_activate (GSimpleAction* _sender,
                                            GVariant* parameter,
                                            gpointer self);
static gboolean __lambda17_ (SwitchboardSwitchboardApp* self,
                      GdkEventButton* event);
static gboolean ___lambda17__gtk_widget_button_release_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self);
static void switchboard_switchboard_app_shut_down (SwitchboardSwitchboardApp* self);
static void _switchboard_switchboard_app_shut_down_gtk_widget_destroy (GtkWidget* _sender,
                                                                gpointer self);
static gboolean __lambda18_ (Block2Data* _data2_,
                      GdkEventConfigure* event);
static gboolean __lambda19_ (Block2Data* _data2_);
static gboolean ___lambda19__gsource_func (gpointer self);
static gboolean ___lambda18__gtk_widget_configure_event (GtkWidget* _sender,
                                                  GdkEventConfigure* event,
                                                  gpointer self);
static gboolean __lambda20_ (SwitchboardSwitchboardApp* self,
                      GdkEventKey* event);
void switchboard_category_view_grab_focus_first_icon_view (SwitchboardCategoryView* self);
static gboolean _vala_uint_array_contains (guint * stack,
                                    int stack_length,
                                    const guint needle);
static gboolean ___lambda20__gtk_widget_key_press_event (GtkWidget* _sender,
                                                  GdkEventKey* event,
                                                  gpointer self);
static void __lambda21_ (SwitchboardSwitchboardApp* self);
static void ___lambda21__gtk_widget_size_allocate (GtkWidget* _sender,
                                            GtkAllocation* allocation,
                                            gpointer self);
static gboolean switchboard_switchboard_app_switch_to_icons (SwitchboardSwitchboardApp* self);
SwitchboardSwitchboardApp* switchboard_switchboard_app_new (void);
SwitchboardSwitchboardApp* switchboard_switchboard_app_construct (GType object_type);
static GObject * switchboard_switchboard_app_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void switchboard_switchboard_app_finalize (GObject * obj);
static void _vala_switchboard_switchboard_app_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_switchboard_switchboard_app_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const guint SWITCHBOARD_SWITCHBOARD_APP_NAVIGATION_KEYS[5] = {GDK_KEY_Up, GDK_KEY_Down, GDK_KEY_Left, GDK_KEY_Right, GDK_KEY_Return};

static gpointer
_g_object_ref0 (gpointer self)
{
#line 28 "../src/Application.vala"
	return self ? g_object_ref (self) : NULL;
#line 274 "Application.c"
}

gint
switchboard_main (gchar** args,
                  gint args_length1)
{
	gint result = 0;
	SwitchboardSwitchboardApp* app = NULL;
	SwitchboardSwitchboardApp* _tmp0_;
	SwitchboardSwitchboardApp* _tmp1_;
	SwitchboardSwitchboardApp* _tmp2_;
#line 26 "../src/Application.vala"
	gtk_clutter_init ((gint*) (&args_length1), &args);
#line 28 "../src/Application.vala"
	_tmp0_ = switchboard_switchboard_app_get_instance ();
#line 28 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 28 "../src/Application.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 28 "../src/Application.vala"
	app = _tmp2_;
#line 29 "../src/Application.vala"
	result = g_application_run ((GApplication*) app, (gint) args_length1, args);
#line 29 "../src/Application.vala"
	_g_object_unref0 (app);
#line 29 "../src/Application.vala"
	return result;
#line 302 "Application.c"
}

int
main (int argc,
      char ** argv)
{
#line 23 "../src/Application.vala"
	return switchboard_main (argv, argc);
#line 311 "Application.c"
}

static inline gpointer
switchboard_switchboard_app_get_instance_private (SwitchboardSwitchboardApp* self)
{
	return G_STRUCT_MEMBER_P (self, SwitchboardSwitchboardApp_private_offset);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 339 "Application.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 343 "Application.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 349 "Application.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 353 "Application.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp0_) {
#line 357 "Application.c"
		gchar* _tmp2_;
#line 1482 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1482 "glib-2.0.vapi"
		result = _tmp2_;
#line 1482 "glib-2.0.vapi"
		return result;
#line 365 "Application.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1485 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1485 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1485 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1485 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1485 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1485 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1485 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1485 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 393 "Application.c"
				goto __catch0_g_regex_error;
			}
#line 1485 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1485 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1485 "glib-2.0.vapi"
			return NULL;
#line 402 "Application.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1486 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1486 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1486 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 416 "Application.c"
				goto __catch0_g_regex_error;
			}
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1486 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1486 "glib-2.0.vapi"
			return NULL;
#line 427 "Application.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1486 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1486 "glib-2.0.vapi"
		result = _tmp10_;
#line 1486 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1486 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
		return result;
#line 441 "Application.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
#line 1484 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1484 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1488 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1484 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 455 "Application.c"
	}
	__finally0:
#line 1484 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1484 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1484 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1484 "glib-2.0.vapi"
		return NULL;
#line 466 "Application.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 490 "Application.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 499 "Application.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 518 "Application.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 522 "Application.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 528 "Application.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 538 "Application.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 546 "Application.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 550 "Application.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 556 "Application.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 566 "Application.c"
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1111 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1112 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1112 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1114 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1114 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 588 "Application.c"
		gchar* _tmp2_;
#line 1115 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1115 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1115 "glib-2.0.vapi"
		return result;
#line 596 "Application.c"
	} else {
#line 1117 "glib-2.0.vapi"
		result = -1;
#line 1117 "glib-2.0.vapi"
		return result;
#line 602 "Application.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 622 "Application.c"
}

static void
switchboard_switchboard_app_real_open (GApplication* base,
                                       GFile** files,
                                       gint files_length1,
                                       const gchar* hint)
{
	SwitchboardSwitchboardApp * self;
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
#line 87 "../src/Application.vala"
	self = (SwitchboardSwitchboardApp*) base;
#line 87 "../src/Application.vala"
	g_return_if_fail (hint != NULL);
#line 88 "../src/Application.vala"
	_tmp0_ = files[0];
#line 88 "../src/Application.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 88 "../src/Application.vala"
	file = _tmp1_;
#line 89 "../src/Application.vala"
	_tmp2_ = file;
#line 89 "../src/Application.vala"
	if (_tmp2_ == NULL) {
#line 90 "../src/Application.vala"
		_g_object_unref0 (file);
#line 90 "../src/Application.vala"
		return;
#line 658 "Application.c"
	}
#line 93 "../src/Application.vala"
	_tmp3_ = file;
#line 93 "../src/Application.vala"
	_tmp4_ = g_file_get_uri_scheme (_tmp3_);
#line 93 "../src/Application.vala"
	_tmp5_ = _tmp4_;
#line 93 "../src/Application.vala"
	_tmp6_ = g_strcmp0 (_tmp5_, "settings") == 0;
#line 93 "../src/Application.vala"
	_g_free0 (_tmp5_);
#line 93 "../src/Application.vala"
	if (_tmp6_) {
#line 672 "Application.c"
		GFile* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		const gchar* _tmp11_;
#line 94 "../src/Application.vala"
		_tmp7_ = file;
#line 94 "../src/Application.vala"
		_tmp8_ = g_file_get_uri (_tmp7_);
#line 94 "../src/Application.vala"
		_tmp9_ = _tmp8_;
#line 94 "../src/Application.vala"
		_tmp10_ = string_replace (_tmp9_, "settings://", "");
#line 94 "../src/Application.vala"
		_g_free0 (switchboard_switchboard_app_link);
#line 94 "../src/Application.vala"
		switchboard_switchboard_app_link = _tmp10_;
#line 94 "../src/Application.vala"
		_g_free0 (_tmp9_);
#line 95 "../src/Application.vala"
		_tmp11_ = switchboard_switchboard_app_link;
#line 95 "../src/Application.vala"
		if (g_str_has_suffix (_tmp11_, "/")) {
#line 696 "Application.c"
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
#line 96 "../src/Application.vala"
			_tmp12_ = switchboard_switchboard_app_link;
#line 96 "../src/Application.vala"
			_tmp13_ = switchboard_switchboard_app_link;
#line 96 "../src/Application.vala"
			_tmp14_ = string_substring (_tmp12_, (glong) 0, (glong) string_last_index_of_char (_tmp13_, (gunichar) '/', 0));
#line 96 "../src/Application.vala"
			_g_free0 (switchboard_switchboard_app_link);
#line 96 "../src/Application.vala"
			switchboard_switchboard_app_link = _tmp14_;
#line 710 "Application.c"
		}
	} else {
		gchar* name = NULL;
		GFile* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
#line 100 "../src/Application.vala"
		g_warning ("Application.vala:100: Calling Switchboard directly is deprecated, plea" \
"se use the settings:// scheme instead");
#line 101 "../src/Application.vala"
		_tmp15_ = file;
#line 101 "../src/Application.vala"
		_tmp16_ = g_file_get_basename (_tmp15_);
#line 101 "../src/Application.vala"
		name = _tmp16_;
#line 102 "../src/Application.vala"
		_tmp17_ = name;
#line 102 "../src/Application.vala"
		if (string_contains (_tmp17_, ":")) {
#line 729 "Application.c"
			gchar** parts = NULL;
			const gchar* _tmp18_;
			gchar** _tmp19_;
			gchar** _tmp20_;
			gint parts_length1;
			gint _parts_size_;
			gchar** _tmp21_;
			gint _tmp21__length1;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar** _tmp24_;
			gint _tmp24__length1;
			const gchar* _tmp25_;
			gchar* _tmp26_;
#line 103 "../src/Application.vala"
			_tmp18_ = name;
#line 103 "../src/Application.vala"
			_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, ":", 0);
#line 103 "../src/Application.vala"
			parts = _tmp20_;
#line 103 "../src/Application.vala"
			parts_length1 = _vala_array_length (_tmp19_);
#line 103 "../src/Application.vala"
			_parts_size_ = parts_length1;
#line 104 "../src/Application.vala"
			_tmp21_ = parts;
#line 104 "../src/Application.vala"
			_tmp21__length1 = parts_length1;
#line 104 "../src/Application.vala"
			_tmp22_ = _tmp21_[0];
#line 104 "../src/Application.vala"
			_tmp23_ = switchboard_switchboard_app_gcc_to_switchboard_code_name (self, _tmp22_);
#line 104 "../src/Application.vala"
			_g_free0 (switchboard_switchboard_app_plug_to_open);
#line 104 "../src/Application.vala"
			switchboard_switchboard_app_plug_to_open = _tmp23_;
#line 105 "../src/Application.vala"
			_tmp24_ = parts;
#line 105 "../src/Application.vala"
			_tmp24__length1 = parts_length1;
#line 105 "../src/Application.vala"
			_tmp25_ = _tmp24_[1];
#line 105 "../src/Application.vala"
			_tmp26_ = g_strdup (_tmp25_);
#line 105 "../src/Application.vala"
			_g_free0 (switchboard_switchboard_app_open_window);
#line 105 "../src/Application.vala"
			switchboard_switchboard_app_open_window = _tmp26_;
#line 102 "../src/Application.vala"
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 780 "Application.c"
		} else {
			const gchar* _tmp27_;
			gchar* _tmp28_;
#line 107 "../src/Application.vala"
			_tmp27_ = name;
#line 107 "../src/Application.vala"
			_tmp28_ = switchboard_switchboard_app_gcc_to_switchboard_code_name (self, _tmp27_);
#line 107 "../src/Application.vala"
			_g_free0 (switchboard_switchboard_app_plug_to_open);
#line 107 "../src/Application.vala"
			switchboard_switchboard_app_plug_to_open = _tmp28_;
#line 792 "Application.c"
		}
#line 93 "../src/Application.vala"
		_g_free0 (name);
#line 796 "Application.c"
	}
#line 111 "../src/Application.vala"
	g_application_activate ((GApplication*) self);
#line 87 "../src/Application.vala"
	_g_object_unref0 (file);
#line 802 "Application.c"
}

static void
switchboard_switchboard_app_real_activate (GApplication* base)
{
	SwitchboardSwitchboardApp * self;
	SwitchboardPlugsManager* plugsmanager = NULL;
	SwitchboardPlugsManager* _tmp0_;
	GSettings* setting = NULL;
	GSettings* _tmp1_;
	GVariant* mapping_dic = NULL;
	GSettings* _tmp2_;
	GVariant* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	GList* _tmp28_;
	GeeLinkedList* _tmp31_;
	GeeArrayList* _tmp32_;
#line 114 "../src/Application.vala"
	self = (SwitchboardSwitchboardApp*) base;
#line 115 "../src/Application.vala"
	_tmp0_ = switchboard_plugs_manager_get_default ();
#line 115 "../src/Application.vala"
	plugsmanager = _tmp0_;
#line 116 "../src/Application.vala"
	_tmp1_ = g_settings_new ("io.elementary.switchboard.preferences");
#line 116 "../src/Application.vala"
	setting = _tmp1_;
#line 117 "../src/Application.vala"
	_tmp2_ = setting;
#line 117 "../src/Application.vala"
	_tmp3_ = g_settings_get_value (_tmp2_, "mapping-override");
#line 117 "../src/Application.vala"
	mapping_dic = _tmp3_;
#line 118 "../src/Application.vala"
	_tmp5_ = switchboard_switchboard_app_link;
#line 118 "../src/Application.vala"
	if (_tmp5_ != NULL) {
#line 841 "Application.c"
		GVariant* _tmp6_;
		const gchar* _tmp7_;
		gboolean _tmp8_;
#line 118 "../src/Application.vala"
		_tmp6_ = mapping_dic;
#line 118 "../src/Application.vala"
		_tmp7_ = switchboard_switchboard_app_link;
#line 118 "../src/Application.vala"
		_tmp8_ = g_variant_lookup (_tmp6_, _tmp7_, "(ss)", &switchboard_switchboard_app_plug_to_open, &switchboard_switchboard_app_open_window, NULL);
#line 118 "../src/Application.vala"
		_tmp4_ = !_tmp8_;
#line 853 "Application.c"
	} else {
#line 118 "../src/Application.vala"
		_tmp4_ = FALSE;
#line 857 "Application.c"
	}
#line 118 "../src/Application.vala"
	if (_tmp4_) {
#line 861 "Application.c"
		gboolean plug_found = FALSE;
		const gchar* _tmp9_;
		SwitchboardPlugsManager* _tmp10_;
#line 119 "../src/Application.vala"
		_tmp9_ = switchboard_switchboard_app_link;
#line 119 "../src/Application.vala"
		_tmp10_ = plugsmanager;
#line 119 "../src/Application.vala"
		plug_found = switchboard_switchboard_app_load_setting_path (self, _tmp9_, _tmp10_);
#line 121 "../src/Application.vala"
		if (plug_found) {
#line 122 "../src/Application.vala"
			_g_free0 (switchboard_switchboard_app_link);
#line 122 "../src/Application.vala"
			switchboard_switchboard_app_link = NULL;
#line 125 "../src/Application.vala"
			switchboard_switchboard_app_should_animate_next_transition = FALSE;
#line 126 "../src/Application.vala"
			switchboard_switchboard_app_opened_directly = TRUE;
#line 881 "Application.c"
		} else {
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 128 "../src/Application.vala"
			_tmp11_ = switchboard_switchboard_app_link;
#line 128 "../src/Application.vala"
			_tmp12_ = g_strdup_printf (_ ("Specified link '%s' does not exist, going back to the main panel"), _tmp11_);
#line 128 "../src/Application.vala"
			_tmp13_ = _tmp12_;
#line 128 "../src/Application.vala"
			g_warning ("Application.vala:128: %s", _tmp13_);
#line 128 "../src/Application.vala"
			_g_free0 (_tmp13_);
#line 896 "Application.c"
		}
	} else {
		const gchar* _tmp14_;
#line 130 "../src/Application.vala"
		_tmp14_ = switchboard_switchboard_app_plug_to_open;
#line 130 "../src/Application.vala"
		if (_tmp14_ != NULL) {
#line 904 "Application.c"
			{
				GeeIterator* _plug_it = NULL;
				SwitchboardPlugsManager* _tmp15_;
				GeeCollection* _tmp16_;
				GeeCollection* _tmp17_;
				GeeIterator* _tmp18_;
				GeeIterator* _tmp19_;
#line 131 "../src/Application.vala"
				_tmp15_ = plugsmanager;
#line 131 "../src/Application.vala"
				_tmp16_ = switchboard_plugs_manager_get_plugs (_tmp15_);
#line 131 "../src/Application.vala"
				_tmp17_ = _tmp16_;
#line 131 "../src/Application.vala"
				_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
#line 131 "../src/Application.vala"
				_tmp19_ = _tmp18_;
#line 131 "../src/Application.vala"
				_g_object_unref0 (_tmp17_);
#line 131 "../src/Application.vala"
				_plug_it = _tmp19_;
#line 131 "../src/Application.vala"
				while (TRUE) {
#line 928 "Application.c"
					GeeIterator* _tmp20_;
					SwitchboardPlug* plug = NULL;
					GeeIterator* _tmp21_;
					gpointer _tmp22_;
					const gchar* _tmp23_;
					SwitchboardPlug* _tmp24_;
					const gchar* _tmp25_;
					const gchar* _tmp26_;
#line 131 "../src/Application.vala"
					_tmp20_ = _plug_it;
#line 131 "../src/Application.vala"
					if (!gee_iterator_next (_tmp20_)) {
#line 131 "../src/Application.vala"
						break;
#line 943 "Application.c"
					}
#line 131 "../src/Application.vala"
					_tmp21_ = _plug_it;
#line 131 "../src/Application.vala"
					_tmp22_ = gee_iterator_get (_tmp21_);
#line 131 "../src/Application.vala"
					plug = (SwitchboardPlug*) _tmp22_;
#line 132 "../src/Application.vala"
					_tmp23_ = switchboard_switchboard_app_plug_to_open;
#line 132 "../src/Application.vala"
					_tmp24_ = plug;
#line 132 "../src/Application.vala"
					_tmp25_ = switchboard_plug_get_code_name (_tmp24_);
#line 132 "../src/Application.vala"
					_tmp26_ = _tmp25_;
#line 132 "../src/Application.vala"
					if (g_str_has_suffix (_tmp23_, _tmp26_)) {
#line 961 "Application.c"
						SwitchboardPlug* _tmp27_;
#line 133 "../src/Application.vala"
						_tmp27_ = plug;
#line 133 "../src/Application.vala"
						switchboard_switchboard_app_load_plug (self, _tmp27_);
#line 134 "../src/Application.vala"
						_g_free0 (switchboard_switchboard_app_plug_to_open);
#line 134 "../src/Application.vala"
						switchboard_switchboard_app_plug_to_open = NULL;
#line 137 "../src/Application.vala"
						switchboard_switchboard_app_should_animate_next_transition = FALSE;
#line 138 "../src/Application.vala"
						switchboard_switchboard_app_opened_directly = TRUE;
#line 139 "../src/Application.vala"
						_g_object_unref0 (plug);
#line 139 "../src/Application.vala"
						break;
#line 979 "Application.c"
					}
#line 131 "../src/Application.vala"
					_g_object_unref0 (plug);
#line 983 "Application.c"
				}
#line 131 "../src/Application.vala"
				_g_object_unref0 (_plug_it);
#line 987 "Application.c"
			}
		}
	}
#line 145 "../src/Application.vala"
	_tmp28_ = gtk_application_get_windows ((GtkApplication*) self);
#line 145 "../src/Application.vala"
	if (g_list_length (_tmp28_) > ((guint) 0)) {
#line 995 "Application.c"
		GList* _tmp29_;
		gconstpointer _tmp30_;
#line 146 "../src/Application.vala"
		_tmp29_ = gtk_application_get_windows ((GtkApplication*) self);
#line 146 "../src/Application.vala"
		_tmp30_ = _tmp29_->data;
#line 146 "../src/Application.vala"
		gtk_window_present ((GtkWindow*) _tmp30_);
#line 147 "../src/Application.vala"
		_g_variant_unref0 (mapping_dic);
#line 147 "../src/Application.vala"
		_g_object_unref0 (setting);
#line 147 "../src/Application.vala"
		_g_object_unref0 (plugsmanager);
#line 147 "../src/Application.vala"
		return;
#line 1012 "Application.c"
	}
#line 150 "../src/Application.vala"
	_tmp31_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 150 "../src/Application.vala"
	_g_object_unref0 (self->priv->loaded_plugs);
#line 150 "../src/Application.vala"
	self->priv->loaded_plugs = _tmp31_;
#line 151 "../src/Application.vala"
	_tmp32_ = gee_array_list_new (SWITCHBOARD_TYPE_PLUG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 151 "../src/Application.vala"
	_g_object_unref0 (self->previous_plugs);
#line 151 "../src/Application.vala"
	self->previous_plugs = _tmp32_;
#line 153 "../src/Application.vala"
	switchboard_switchboard_app_build (self);
#line 155 "../src/Application.vala"
	gtk_main ();
#line 114 "../src/Application.vala"
	_g_variant_unref0 (mapping_dic);
#line 114 "../src/Application.vala"
	_g_object_unref0 (setting);
#line 114 "../src/Application.vala"
	_g_object_unref0 (plugsmanager);
#line 1036 "Application.c"
}

void
switchboard_switchboard_app_hide_alert (SwitchboardSwitchboardApp* self)
{
	GtkStack* _tmp0_;
#line 158 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/Application.vala"
	_tmp0_ = self->priv->stack;
#line 159 "../src/Application.vala"
	gtk_stack_set_visible_child_full (_tmp0_, "main", GTK_STACK_TRANSITION_TYPE_NONE);
#line 1049 "Application.c"
}

void
switchboard_switchboard_app_show_alert (SwitchboardSwitchboardApp* self,
                                        const gchar* primary_text,
                                        const gchar* secondary_text,
                                        const gchar* icon_name)
{
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
	GraniteWidgetsAlertView* _tmp2_;
	GraniteWidgetsAlertView* _tmp3_;
	GtkStack* _tmp4_;
#line 162 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/Application.vala"
	g_return_if_fail (primary_text != NULL);
#line 162 "../src/Application.vala"
	g_return_if_fail (secondary_text != NULL);
#line 162 "../src/Application.vala"
	g_return_if_fail (icon_name != NULL);
#line 163 "../src/Application.vala"
	_tmp0_ = self->priv->alert_view;
#line 163 "../src/Application.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp0_);
#line 164 "../src/Application.vala"
	_tmp1_ = self->priv->alert_view;
#line 164 "../src/Application.vala"
	granite_widgets_alert_view_set_title (_tmp1_, primary_text);
#line 165 "../src/Application.vala"
	_tmp2_ = self->priv->alert_view;
#line 165 "../src/Application.vala"
	granite_widgets_alert_view_set_description (_tmp2_, secondary_text);
#line 166 "../src/Application.vala"
	_tmp3_ = self->priv->alert_view;
#line 166 "../src/Application.vala"
	granite_widgets_alert_view_set_icon_name (_tmp3_, icon_name);
#line 167 "../src/Application.vala"
	_tmp4_ = self->priv->stack;
#line 167 "../src/Application.vala"
	gtk_stack_set_visible_child_full (_tmp4_, "alert", GTK_STACK_TRANSITION_TYPE_NONE);
#line 1091 "Application.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 170 "../src/Application.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 170 "../src/Application.vala"
	return _data1_;
#line 1101 "Application.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 170 "../src/Application.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1111 "Application.c"
		SwitchboardSwitchboardApp* self;
#line 170 "../src/Application.vala"
		self = _data1_->self;
#line 170 "../src/Application.vala"
		_g_object_unref0 (_data1_->plug);
#line 170 "../src/Application.vala"
		_g_object_unref0 (self);
#line 170 "../src/Application.vala"
		g_slice_free (Block1Data, _data1_);
#line 1121 "Application.c"
	}
}

static gboolean
__lambda7_ (Block1Data* _data1_,
            SwitchboardSearchEntry* entry)
{
	SwitchboardSwitchboardApp* self;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 183 "../src/Application.vala"
	self = _data1_->self;
#line 184 "../src/Application.vala"
	_tmp0_ = switchboard_plug_get_display_name (_data1_->plug);
#line 184 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 184 "../src/Application.vala"
	_tmp2_ = (*entry).plug_name;
#line 184 "../src/Application.vala"
	if (g_strcmp0 (_tmp1_, _tmp2_) == 0) {
#line 1144 "Application.c"
		const gchar* _tmp3_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 185 "../src/Application.vala"
		_tmp3_ = (*entry).open_window;
#line 185 "../src/Application.vala"
		if (_tmp3_ == NULL) {
#line 186 "../src/Application.vala"
			switchboard_plug_search_callback (_data1_->plug, "");
#line 1155 "Application.c"
		} else {
			const gchar* _tmp4_;
#line 188 "../src/Application.vala"
			_tmp4_ = (*entry).open_window;
#line 188 "../src/Application.vala"
			switchboard_plug_search_callback (_data1_->plug, _tmp4_);
#line 1162 "Application.c"
		}
#line 190 "../src/Application.vala"
		_tmp5_ = (*entry).open_window;
#line 190 "../src/Application.vala"
		_tmp6_ = switchboard_plug_get_display_name (_data1_->plug);
#line 190 "../src/Application.vala"
		_tmp7_ = _tmp6_;
#line 190 "../src/Application.vala"
		g_debug ("Application.vala:190: open section:%s of plug: %s", _tmp5_, _tmp7_);
#line 191 "../src/Application.vala"
		result = TRUE;
#line 191 "../src/Application.vala"
		_switchboard_search_entry_free0 (entry);
#line 191 "../src/Application.vala"
		return result;
#line 1178 "Application.c"
	}
#line 194 "../src/Application.vala"
	result = FALSE;
#line 194 "../src/Application.vala"
	_switchboard_search_entry_free0 (entry);
#line 194 "../src/Application.vala"
	return result;
#line 1186 "Application.c"
}

static gboolean
___lambda7__gee_forall_func (gpointer g,
                             gpointer self)
{
	gboolean result;
	result = __lambda7_ (self, (SwitchboardSearchEntry*) g);
#line 183 "../src/Application.vala"
	return result;
#line 1197 "Application.c"
}

static gboolean
__lambda6_ (Block1Data* _data1_)
{
	SwitchboardSwitchboardApp* self;
	gboolean result = FALSE;
	GeeLinkedList* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	SwitchboardCategoryView* _tmp11_;
	GeeArrayList* _tmp12_;
	GeeArrayList* _tmp13_;
	gboolean _tmp14_ = FALSE;
	GeeArrayList* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GtkButton* _tmp22_;
	const gchar* _tmp23_;
	GtkButton* _tmp24_;
	GtkHeaderBar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	SwitchboardPlug* _tmp28_;
	const gchar* _tmp29_;
#line 177 "../src/Application.vala"
	self = _data1_->self;
#line 178 "../src/Application.vala"
	_tmp0_ = self->priv->loaded_plugs;
#line 178 "../src/Application.vala"
	_tmp1_ = switchboard_plug_get_code_name (_data1_->plug);
#line 178 "../src/Application.vala"
	_tmp2_ = _tmp1_;
#line 178 "../src/Application.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _tmp2_)) {
#line 1233 "Application.c"
		GtkStack* _tmp3_;
		GtkWidget* _tmp4_;
		GtkWidget* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		GeeLinkedList* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 179 "../src/Application.vala"
		_tmp3_ = self->priv->stack;
#line 179 "../src/Application.vala"
		_tmp4_ = switchboard_plug_get_widget (_data1_->plug);
#line 179 "../src/Application.vala"
		_tmp5_ = _tmp4_;
#line 179 "../src/Application.vala"
		_tmp6_ = switchboard_plug_get_code_name (_data1_->plug);
#line 179 "../src/Application.vala"
		_tmp7_ = _tmp6_;
#line 179 "../src/Application.vala"
		gtk_stack_add_named (_tmp3_, _tmp5_, _tmp7_);
#line 179 "../src/Application.vala"
		_g_object_unref0 (_tmp5_);
#line 180 "../src/Application.vala"
		_tmp8_ = self->priv->loaded_plugs;
#line 180 "../src/Application.vala"
		_tmp9_ = switchboard_plug_get_code_name (_data1_->plug);
#line 180 "../src/Application.vala"
		_tmp10_ = _tmp9_;
#line 180 "../src/Application.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp10_);
#line 1264 "Application.c"
	}
#line 183 "../src/Application.vala"
	_tmp11_ = self->category_view;
#line 183 "../src/Application.vala"
	_tmp12_ = switchboard_category_view_get_plug_search_result (_tmp11_);
#line 183 "../src/Application.vala"
	_tmp13_ = _tmp12_;
#line 183 "../src/Application.vala"
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp13_, ___lambda7__gee_forall_func, _data1_);
#line 197 "../src/Application.vala"
	_tmp15_ = self->previous_plugs;
#line 197 "../src/Application.vala"
	_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 197 "../src/Application.vala"
	_tmp17_ = _tmp16_;
#line 197 "../src/Application.vala"
	if (_tmp17_ == 0) {
#line 197 "../src/Application.vala"
		_tmp14_ = TRUE;
#line 1284 "Application.c"
	} else {
		GeeArrayList* _tmp18_;
		gpointer _tmp19_;
		SwitchboardPlug* _tmp20_;
#line 197 "../src/Application.vala"
		_tmp18_ = self->previous_plugs;
#line 197 "../src/Application.vala"
		_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, 0);
#line 197 "../src/Application.vala"
		_tmp20_ = (SwitchboardPlug*) _tmp19_;
#line 197 "../src/Application.vala"
		_tmp14_ = _tmp20_ != _data1_->plug;
#line 197 "../src/Application.vala"
		_g_object_unref0 (_tmp20_);
#line 1299 "Application.c"
	}
#line 197 "../src/Application.vala"
	if (_tmp14_) {
#line 1303 "Application.c"
		GeeArrayList* _tmp21_;
#line 198 "../src/Application.vala"
		_tmp21_ = self->previous_plugs;
#line 198 "../src/Application.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _data1_->plug);
#line 1309 "Application.c"
	}
#line 202 "../src/Application.vala"
	_tmp22_ = self->priv->navigation_button;
#line 202 "../src/Application.vala"
	_tmp23_ = self->priv->all_settings_label;
#line 202 "../src/Application.vala"
	gtk_button_set_label (_tmp22_, _tmp23_);
#line 203 "../src/Application.vala"
	_tmp24_ = self->priv->navigation_button;
#line 203 "../src/Application.vala"
	gtk_widget_show ((GtkWidget*) _tmp24_);
#line 205 "../src/Application.vala"
	_tmp25_ = self->priv->headerbar;
#line 205 "../src/Application.vala"
	_tmp26_ = switchboard_plug_get_display_name (_data1_->plug);
#line 205 "../src/Application.vala"
	_tmp27_ = _tmp26_;
#line 205 "../src/Application.vala"
	gtk_header_bar_set_title (_tmp25_, _tmp27_);
#line 206 "../src/Application.vala"
	_tmp28_ = _g_object_ref0 (_data1_->plug);
#line 206 "../src/Application.vala"
	_g_object_unref0 (self->current_plug);
#line 206 "../src/Application.vala"
	self->current_plug = _tmp28_;
#line 209 "../src/Application.vala"
	_tmp29_ = switchboard_switchboard_app_open_window;
#line 209 "../src/Application.vala"
	if (_tmp29_ != NULL) {
#line 1339 "Application.c"
		const gchar* _tmp30_;
#line 210 "../src/Application.vala"
		_tmp30_ = switchboard_switchboard_app_open_window;
#line 210 "../src/Application.vala"
		switchboard_plug_search_callback (_data1_->plug, _tmp30_);
#line 211 "../src/Application.vala"
		_g_free0 (switchboard_switchboard_app_open_window);
#line 211 "../src/Application.vala"
		switchboard_switchboard_app_open_window = NULL;
#line 1349 "Application.c"
	}
#line 214 "../src/Application.vala"
	switchboard_switchboard_app_switch_to_plug (self, _data1_->plug);
#line 215 "../src/Application.vala"
	result = FALSE;
#line 215 "../src/Application.vala"
	return result;
#line 1357 "Application.c"
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ (self);
#line 177 "../src/Application.vala"
	return result;
#line 1367 "Application.c"
}

void
switchboard_switchboard_app_load_plug (SwitchboardSwitchboardApp* self,
                                       SwitchboardPlug* plug)
{
	Block1Data* _data1_;
	SwitchboardPlug* _tmp0_;
	gint priority = 0;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 170 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/Application.vala"
	g_return_if_fail (plug != NULL);
#line 170 "../src/Application.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 170 "../src/Application.vala"
	_data1_->_ref_count_ = 1;
#line 170 "../src/Application.vala"
	_data1_->self = g_object_ref (self);
#line 170 "../src/Application.vala"
	_tmp0_ = _g_object_ref0 (plug);
#line 170 "../src/Application.vala"
	_g_object_unref0 (_data1_->plug);
#line 170 "../src/Application.vala"
	_data1_->plug = _tmp0_;
#line 172 "../src/Application.vala"
	priority = G_PRIORITY_DEFAULT_IDLE;
#line 173 "../src/Application.vala"
	_tmp1_ = switchboard_plug_get_code_name (_data1_->plug);
#line 173 "../src/Application.vala"
	_tmp2_ = _tmp1_;
#line 173 "../src/Application.vala"
	if (string_contains (_tmp2_, "-gcc-")) {
#line 174 "../src/Application.vala"
		priority = G_PRIORITY_LOW;
#line 1405 "Application.c"
	}
#line 177 "../src/Application.vala"
	g_idle_add_full (priority, ___lambda6__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 170 "../src/Application.vala"
	block1_data_unref (_data1_);
#line 170 "../src/Application.vala"
	_data1_ = NULL;
#line 1413 "Application.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 252 "../src/Application.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 252 "../src/Application.vala"
	return _data2_;
#line 1423 "Application.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 252 "../src/Application.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1433 "Application.c"
		SwitchboardSwitchboardApp* self;
#line 252 "../src/Application.vala"
		self = _data2_->self;
#line 252 "../src/Application.vala"
		_g_object_unref0 (_data2_->settings);
#line 252 "../src/Application.vala"
		_g_object_unref0 (self);
#line 252 "../src/Application.vala"
		g_slice_free (Block2Data, _data2_);
#line 1443 "Application.c"
	}
}

static void
__lambda12_ (SwitchboardSwitchboardApp* self,
             SwitchboardPlug* plug)
{
#line 282 "../src/Application.vala"
	g_return_if_fail (plug != NULL);
#line 282 "../src/Application.vala"
	switchboard_switchboard_app_load_plug (self, plug);
#line 1455 "Application.c"
}

static void
___lambda12__switchboard_category_view_plug_selected (SwitchboardCategoryView* _sender,
                                                      SwitchboardPlug* plug,
                                                      gpointer self)
{
#line 282 "../src/Application.vala"
	__lambda12_ ((SwitchboardSwitchboardApp*) self, plug);
#line 1465 "Application.c"
}

static void
__lambda13_ (SwitchboardSwitchboardApp* self)
{
	SwitchboardCategoryView* _tmp0_;
	GtkSearchEntry* _tmp1_;
	const gchar* _tmp2_;
#line 328 "../src/Application.vala"
	_tmp0_ = self->category_view;
#line 328 "../src/Application.vala"
	_tmp1_ = self->priv->_search_box;
#line 328 "../src/Application.vala"
	_tmp2_ = gtk_entry_get_text ((GtkEntry*) _tmp1_);
#line 328 "../src/Application.vala"
	switchboard_category_view_filter_plugs (_tmp0_, _tmp2_);
#line 1482 "Application.c"
}

static void
___lambda13__gtk_editable_changed (GtkEditable* _sender,
                                   gpointer self)
{
#line 327 "../src/Application.vala"
	__lambda13_ ((SwitchboardSwitchboardApp*) self);
#line 1491 "Application.c"
}

static gboolean
__lambda14_ (SwitchboardSwitchboardApp* self,
             GdkEventKey* event)
{
	gboolean result = FALSE;
#line 331 "../src/Application.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 332 "../src/Application.vala"
	switch (event->keyval) {
#line 332 "../src/Application.vala"
		case GDK_KEY_Return:
#line 1505 "Application.c"
		{
			SwitchboardCategoryView* _tmp0_;
#line 334 "../src/Application.vala"
			_tmp0_ = self->category_view;
#line 334 "../src/Application.vala"
			switchboard_category_view_activate_first_item (_tmp0_);
#line 335 "../src/Application.vala"
			result = TRUE;
#line 335 "../src/Application.vala"
			return result;
#line 1516 "Application.c"
		}
#line 332 "../src/Application.vala"
		case GDK_KEY_Escape:
#line 1520 "Application.c"
		{
			GtkSearchEntry* _tmp1_;
#line 337 "../src/Application.vala"
			_tmp1_ = self->priv->_search_box;
#line 337 "../src/Application.vala"
			gtk_entry_set_text ((GtkEntry*) _tmp1_, "");
#line 338 "../src/Application.vala"
			result = TRUE;
#line 338 "../src/Application.vala"
			return result;
#line 1531 "Application.c"
		}
		default:
		{
#line 340 "../src/Application.vala"
			break;
#line 1537 "Application.c"
		}
	}
#line 343 "../src/Application.vala"
	result = FALSE;
#line 343 "../src/Application.vala"
	return result;
#line 1544 "Application.c"
}

static gboolean
___lambda14__gtk_widget_key_press_event (GtkWidget* _sender,
                                         GdkEventKey* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda14_ ((SwitchboardSwitchboardApp*) self, event);
#line 331 "../src/Application.vala"
	return result;
#line 1556 "Application.c"
}

static void
__lambda15_ (SwitchboardSwitchboardApp* self)
{
#line 347 "../src/Application.vala"
	switchboard_switchboard_app_handle_navigation_button_clicked (self);
#line 1564 "Application.c"
}

static void
___lambda15__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
#line 346 "../src/Application.vala"
	__lambda15_ ((SwitchboardSwitchboardApp*) self);
#line 1574 "Application.c"
}

static void
__lambda16_ (SwitchboardSwitchboardApp* self)
{
	GtkWindow* _tmp0_;
#line 351 "../src/Application.vala"
	_tmp0_ = self->priv->main_window;
#line 351 "../src/Application.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp0_);
#line 1585 "Application.c"
}

static void
___lambda16__g_simple_action_activate (GSimpleAction* _sender,
                                       GVariant* parameter,
                                       gpointer self)
{
#line 350 "../src/Application.vala"
	__lambda16_ ((SwitchboardSwitchboardApp*) self);
#line 1595 "Application.c"
}

static gboolean
__lambda17_ (SwitchboardSwitchboardApp* self,
             GdkEventButton* event)
{
	gboolean result = FALSE;
#line 354 "../src/Application.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 356 "../src/Application.vala"
	if (event->button == ((guint) 8)) {
#line 1607 "Application.c"
		GtkButton* _tmp0_;
#line 357 "../src/Application.vala"
		_tmp0_ = self->priv->navigation_button;
#line 357 "../src/Application.vala"
		gtk_button_clicked (_tmp0_);
#line 1613 "Application.c"
	}
#line 360 "../src/Application.vala"
	result = FALSE;
#line 360 "../src/Application.vala"
	return result;
#line 1619 "Application.c"
}

static gboolean
___lambda17__gtk_widget_button_release_event (GtkWidget* _sender,
                                              GdkEventButton* event,
                                              gpointer self)
{
	gboolean result;
	result = __lambda17_ ((SwitchboardSwitchboardApp*) self, event);
#line 354 "../src/Application.vala"
	return result;
#line 1631 "Application.c"
}

static void
_switchboard_switchboard_app_shut_down_gtk_widget_destroy (GtkWidget* _sender,
                                                           gpointer self)
{
#line 363 "../src/Application.vala"
	switchboard_switchboard_app_shut_down ((SwitchboardSwitchboardApp*) self);
#line 1640 "Application.c"
}

static gboolean
__lambda19_ (Block2Data* _data2_)
{
	SwitchboardSwitchboardApp* self;
	gboolean result = FALSE;
	GtkWindow* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 370 "../src/Application.vala"
	self = _data2_->self;
#line 371 "../src/Application.vala"
	self->priv->configure_id = (guint) 0;
#line 373 "../src/Application.vala"
	_tmp0_ = self->priv->main_window;
#line 373 "../src/Application.vala"
	g_object_get (_tmp0_, "is-maximized", &_tmp1_, NULL);
#line 373 "../src/Application.vala"
	_tmp2_ = _tmp1_;
#line 373 "../src/Application.vala"
	if (_tmp2_) {
#line 1663 "Application.c"
		GSettings* _tmp3_;
#line 374 "../src/Application.vala"
		_tmp3_ = _data2_->settings;
#line 374 "../src/Application.vala"
		g_settings_set_boolean (_tmp3_, "window-maximized", TRUE);
#line 1669 "Application.c"
	} else {
		GSettings* _tmp4_;
		GtkWindow* _tmp5_;
		GtkAllocation _tmp6_ = {0};
		GSettings* _tmp7_;
		GtkAllocation _tmp8_;
		GtkAllocation _tmp9_;
		gint root_x = 0;
		gint root_y = 0;
		GtkWindow* _tmp10_;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		GSettings* _tmp13_;
#line 376 "../src/Application.vala"
		_tmp4_ = _data2_->settings;
#line 376 "../src/Application.vala"
		g_settings_set_boolean (_tmp4_, "window-maximized", FALSE);
#line 378 "../src/Application.vala"
		_tmp5_ = self->priv->main_window;
#line 378 "../src/Application.vala"
		gtk_widget_get_allocation ((GtkWidget*) _tmp5_, &_tmp6_);
#line 378 "../src/Application.vala"
		_data2_->rect = _tmp6_;
#line 379 "../src/Application.vala"
		_tmp7_ = _data2_->settings;
#line 379 "../src/Application.vala"
		_tmp8_ = _data2_->rect;
#line 379 "../src/Application.vala"
		_tmp9_ = _data2_->rect;
#line 379 "../src/Application.vala"
		g_settings_set (_tmp7_, "window-size", "(ii)", _tmp8_.width, _tmp9_.height);
#line 382 "../src/Application.vala"
		_tmp10_ = self->priv->main_window;
#line 382 "../src/Application.vala"
		gtk_window_get_position (_tmp10_, &_tmp11_, &_tmp12_);
#line 382 "../src/Application.vala"
		root_x = _tmp11_;
#line 382 "../src/Application.vala"
		root_y = _tmp12_;
#line 383 "../src/Application.vala"
		_tmp13_ = _data2_->settings;
#line 383 "../src/Application.vala"
		g_settings_set (_tmp13_, "window-position", "(ii)", root_x, root_y);
#line 1713 "Application.c"
	}
#line 386 "../src/Application.vala"
	result = FALSE;
#line 386 "../src/Application.vala"
	return result;
#line 1719 "Application.c"
}

static gboolean
___lambda19__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda19_ (self);
#line 370 "../src/Application.vala"
	return result;
#line 1729 "Application.c"
}

static gboolean
__lambda18_ (Block2Data* _data2_,
             GdkEventConfigure* event)
{
	SwitchboardSwitchboardApp* self;
	gboolean result = FALSE;
#line 365 "../src/Application.vala"
	self = _data2_->self;
#line 365 "../src/Application.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 366 "../src/Application.vala"
	if (self->priv->configure_id != ((guint) 0)) {
#line 367 "../src/Application.vala"
		g_source_remove (self->priv->configure_id);
#line 1746 "Application.c"
	}
#line 370 "../src/Application.vala"
	self->priv->configure_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda19__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 389 "../src/Application.vala"
	result = FALSE;
#line 389 "../src/Application.vala"
	return result;
#line 1754 "Application.c"
}

static gboolean
___lambda18__gtk_widget_configure_event (GtkWidget* _sender,
                                         GdkEventConfigure* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda18_ (self, event);
#line 365 "../src/Application.vala"
	return result;
#line 1766 "Application.c"
}

static gboolean
_vala_uint_array_contains (guint * stack,
                           int stack_length,
                           const guint needle)
{
	int i;
#line 400 "../src/Application.vala"
	for (i = 0; i < stack_length; i++) {
#line 400 "../src/Application.vala"
		if (needle == stack[i]) {
#line 400 "../src/Application.vala"
			return TRUE;
#line 1781 "Application.c"
		}
	}
#line 400 "../src/Application.vala"
	return FALSE;
#line 1786 "Application.c"
}

static gboolean
__lambda20_ (SwitchboardSwitchboardApp* self,
             GdkEventKey* event)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkSearchEntry* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp5_ = FALSE;
#line 392 "../src/Application.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 394 "../src/Application.vala"
	_tmp1_ = self->priv->_search_box;
#line 394 "../src/Application.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 394 "../src/Application.vala"
	_tmp3_ = _tmp2_;
#line 394 "../src/Application.vala"
	if (_tmp3_) {
#line 394 "../src/Application.vala"
		_tmp0_ = event->keyval == GDK_KEY_Down;
#line 1811 "Application.c"
	} else {
#line 394 "../src/Application.vala"
		_tmp0_ = FALSE;
#line 1815 "Application.c"
	}
#line 394 "../src/Application.vala"
	if (_tmp0_) {
#line 1819 "Application.c"
		SwitchboardCategoryView* _tmp4_;
#line 395 "../src/Application.vala"
		_tmp4_ = self->category_view;
#line 395 "../src/Application.vala"
		switchboard_category_view_grab_focus_first_icon_view (_tmp4_);
#line 396 "../src/Application.vala"
		result = FALSE;
#line 396 "../src/Application.vala"
		return result;
#line 1829 "Application.c"
	}
#line 400 "../src/Application.vala"
	if (_vala_uint_array_contains (SWITCHBOARD_SWITCHBOARD_APP_NAVIGATION_KEYS, G_N_ELEMENTS (SWITCHBOARD_SWITCHBOARD_APP_NAVIGATION_KEYS), event->keyval)) {
#line 401 "../src/Application.vala"
		result = FALSE;
#line 401 "../src/Application.vala"
		return result;
#line 1837 "Application.c"
	}
#line 404 "../src/Application.vala"
	if (event->is_modifier == ((guint) 0)) {
#line 1841 "Application.c"
		GtkSearchEntry* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 404 "../src/Application.vala"
		_tmp6_ = self->priv->_search_box;
#line 404 "../src/Application.vala"
		g_object_get ((GtkWidget*) _tmp6_, "has-focus", &_tmp7_, NULL);
#line 404 "../src/Application.vala"
		_tmp8_ = _tmp7_;
#line 404 "../src/Application.vala"
		_tmp5_ = !_tmp8_;
#line 1853 "Application.c"
	} else {
#line 404 "../src/Application.vala"
		_tmp5_ = FALSE;
#line 1857 "Application.c"
	}
#line 404 "../src/Application.vala"
	if (_tmp5_) {
#line 1861 "Application.c"
		GtkSearchEntry* _tmp9_;
#line 405 "../src/Application.vala"
		_tmp9_ = self->priv->_search_box;
#line 405 "../src/Application.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
#line 1867 "Application.c"
	}
#line 407 "../src/Application.vala"
	result = FALSE;
#line 407 "../src/Application.vala"
	return result;
#line 1873 "Application.c"
}

static gboolean
___lambda20__gtk_widget_key_press_event (GtkWidget* _sender,
                                         GdkEventKey* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda20_ ((SwitchboardSwitchboardApp*) self, event);
#line 392 "../src/Application.vala"
	return result;
#line 1885 "Application.c"
}

static void
__lambda21_ (SwitchboardSwitchboardApp* self)
{
#line 411 "../src/Application.vala"
	if (switchboard_switchboard_app_opened_directly) {
#line 1893 "Application.c"
		GtkSearchEntry* _tmp0_;
#line 412 "../src/Application.vala"
		_tmp0_ = self->priv->_search_box;
#line 412 "../src/Application.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 1899 "Application.c"
	}
}

static void
___lambda21__gtk_widget_size_allocate (GtkWidget* _sender,
                                       GtkAllocation* allocation,
                                       gpointer self)
{
#line 410 "../src/Application.vala"
	__lambda21_ ((SwitchboardSwitchboardApp*) self);
#line 1910 "Application.c"
}

static void
switchboard_switchboard_app_build (SwitchboardSwitchboardApp* self)
{
	Block2Data* _data2_;
	GSimpleAction* back_action = NULL;
	GSimpleAction* _tmp0_;
	GSimpleAction* quit_action = NULL;
	GSimpleAction* _tmp1_;
	GSimpleAction* _tmp2_;
	GSimpleAction* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GtkButton* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkSearchEntry* _tmp24_;
	GtkSearchEntry* _tmp25_;
	GtkSearchEntry* _tmp26_;
	GtkSearchEntry* _tmp27_;
	GtkHeaderBar* _tmp28_;
	GtkHeaderBar* _tmp29_;
	GtkHeaderBar* _tmp30_;
	GtkHeaderBar* _tmp31_;
	GtkHeaderBar* _tmp32_;
	GtkButton* _tmp33_;
	GtkHeaderBar* _tmp34_;
	GtkSearchEntry* _tmp35_;
	const gchar* _tmp36_;
	SwitchboardCategoryView* _tmp37_;
	SwitchboardCategoryView* _tmp38_;
	SwitchboardCategoryView* _tmp39_;
	SwitchboardCategoryView* _tmp40_;
	GtkScrolledWindow* _tmp41_;
	GtkScrolledWindow* _tmp42_;
	SwitchboardCategoryView* _tmp43_;
	GraniteWidgetsAlertView* _tmp44_;
	GraniteWidgetsAlertView* _tmp45_;
	GtkStyleContext* _tmp46_;
	GtkStack* _tmp47_;
	GtkStack* _tmp48_;
	GtkStack* _tmp49_;
	GraniteWidgetsAlertView* _tmp50_;
	GtkStack* _tmp51_;
	GtkScrolledWindow* _tmp52_;
	GtkWindow* _tmp53_;
	GtkWindow* _tmp54_;
	GtkWindow* _tmp55_;
	GtkWindow* _tmp56_;
	GtkWindow* _tmp57_;
	GtkStack* _tmp58_;
	GtkWindow* _tmp59_;
	GtkWindow* _tmp60_;
	GtkHeaderBar* _tmp61_;
	gint window_x = 0;
	gint window_y = 0;
	GSettings* _tmp62_;
	GSettings* _tmp63_;
	gint _tmp64_ = 0;
	gint _tmp65_ = 0;
	GSettings* _tmp66_;
	gint _tmp67_ = 0;
	gint _tmp68_ = 0;
	gboolean _tmp69_ = FALSE;
	GtkWindow* _tmp71_;
	GtkAllocation _tmp72_;
	GSettings* _tmp73_;
	GtkWindow* _tmp75_;
	GtkButton* _tmp76_;
	GtkWindow* _tmp77_;
	GtkSearchEntry* _tmp78_;
	GtkSearchEntry* _tmp79_;
	GSimpleAction* _tmp80_;
	GSimpleAction* _tmp81_;
	GtkWindow* _tmp82_;
	GtkWindow* _tmp83_;
	GtkWindow* _tmp84_;
	GtkWindow* _tmp85_;
	GtkWindow* _tmp86_;
	SwitchboardPlugsManager* _tmp87_;
	SwitchboardPlugsManager* _tmp88_;
	gboolean _tmp89_;
#line 252 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/Application.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 252 "../src/Application.vala"
	_data2_->_ref_count_ = 1;
#line 252 "../src/Application.vala"
	_data2_->self = g_object_ref (self);
#line 253 "../src/Application.vala"
	_tmp0_ = g_simple_action_new ("back", NULL);
#line 253 "../src/Application.vala"
	back_action = _tmp0_;
#line 254 "../src/Application.vala"
	_tmp1_ = g_simple_action_new ("quit", NULL);
#line 254 "../src/Application.vala"
	quit_action = _tmp1_;
#line 256 "../src/Application.vala"
	_tmp2_ = back_action;
#line 256 "../src/Application.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp2_);
#line 257 "../src/Application.vala"
	_tmp3_ = quit_action;
#line 257 "../src/Application.vala"
	g_action_map_add_action ((GActionMap*) self, (GAction*) _tmp3_);
#line 259 "../src/Application.vala"
	_tmp4_ = g_strdup ("<Alt>Left");
#line 259 "../src/Application.vala"
	_tmp5_ = g_strdup ("Back");
#line 259 "../src/Application.vala"
	_tmp6_ = g_new0 (gchar*, 2 + 1);
#line 259 "../src/Application.vala"
	_tmp6_[0] = _tmp4_;
#line 259 "../src/Application.vala"
	_tmp6_[1] = _tmp5_;
#line 259 "../src/Application.vala"
	_tmp7_ = _tmp6_;
#line 259 "../src/Application.vala"
	_tmp7__length1 = 2;
#line 259 "../src/Application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.back", _tmp7_);
#line 259 "../src/Application.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 260 "../src/Application.vala"
	_tmp8_ = g_strdup ("<Control>q");
#line 260 "../src/Application.vala"
	_tmp9_ = g_new0 (gchar*, 1 + 1);
#line 260 "../src/Application.vala"
	_tmp9_[0] = _tmp8_;
#line 260 "../src/Application.vala"
	_tmp10_ = _tmp9_;
#line 260 "../src/Application.vala"
	_tmp10__length1 = 1;
#line 260 "../src/Application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.quit", _tmp10_);
#line 260 "../src/Application.vala"
	_tmp10_ = (_vala_array_free (_tmp10_, _tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 262 "../src/Application.vala"
	_tmp11_ = (GtkButton*) gtk_button_new ();
#line 262 "../src/Application.vala"
	g_object_ref_sink (_tmp11_);
#line 262 "../src/Application.vala"
	_g_object_unref0 (self->priv->navigation_button);
#line 262 "../src/Application.vala"
	self->priv->navigation_button = _tmp11_;
#line 263 "../src/Application.vala"
	_tmp12_ = self->priv->navigation_button;
#line 263 "../src/Application.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp12_, "app.back");
#line 264 "../src/Application.vala"
	_tmp13_ = self->priv->navigation_button;
#line 264 "../src/Application.vala"
	_tmp14_ = self->priv->navigation_button;
#line 264 "../src/Application.vala"
	_tmp15_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp14_);
#line 264 "../src/Application.vala"
	_tmp16_ = _tmp15_;
#line 264 "../src/Application.vala"
	_tmp18_ = _tmp17_ = gtk_application_get_accels_for_action ((GtkApplication*) self, _tmp16_);
#line 264 "../src/Application.vala"
	_tmp19_ = _tmp18_;
#line 264 "../src/Application.vala"
	_tmp19__length1 = _vala_array_length (_tmp17_);
#line 264 "../src/Application.vala"
	_tmp20_ = granite_markup_accel_tooltip (_tmp19_, (gint) _vala_array_length (_tmp17_), NULL);
#line 264 "../src/Application.vala"
	_tmp21_ = _tmp20_;
#line 264 "../src/Application.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp13_, _tmp21_);
#line 264 "../src/Application.vala"
	_g_free0 (_tmp21_);
#line 264 "../src/Application.vala"
	_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 267 "../src/Application.vala"
	_tmp22_ = self->priv->navigation_button;
#line 267 "../src/Application.vala"
	_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) _tmp22_);
#line 267 "../src/Application.vala"
	gtk_style_context_add_class (_tmp23_, "back-button");
#line 269 "../src/Application.vala"
	_tmp24_ = (GtkSearchEntry*) gtk_search_entry_new ();
#line 269 "../src/Application.vala"
	g_object_ref_sink (_tmp24_);
#line 269 "../src/Application.vala"
	_tmp25_ = _tmp24_;
#line 269 "../src/Application.vala"
	switchboard_switchboard_app_set_search_box (self, _tmp25_);
#line 269 "../src/Application.vala"
	_g_object_unref0 (_tmp25_);
#line 270 "../src/Application.vala"
	_tmp26_ = self->priv->_search_box;
#line 270 "../src/Application.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp26_, _ ("Search Settings"));
#line 271 "../src/Application.vala"
	_tmp27_ = self->priv->_search_box;
#line 271 "../src/Application.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp27_, FALSE);
#line 273 "../src/Application.vala"
	_tmp28_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 273 "../src/Application.vala"
	g_object_ref_sink (_tmp28_);
#line 273 "../src/Application.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 273 "../src/Application.vala"
	self->priv->headerbar = _tmp28_;
#line 274 "../src/Application.vala"
	_tmp29_ = self->priv->headerbar;
#line 274 "../src/Application.vala"
	gtk_header_bar_set_has_subtitle (_tmp29_, FALSE);
#line 275 "../src/Application.vala"
	_tmp30_ = self->priv->headerbar;
#line 275 "../src/Application.vala"
	gtk_header_bar_set_show_close_button (_tmp30_, TRUE);
#line 276 "../src/Application.vala"
	_tmp31_ = self->priv->headerbar;
#line 276 "../src/Application.vala"
	gtk_header_bar_set_title (_tmp31_, _ ("System Settings"));
#line 277 "../src/Application.vala"
	_tmp32_ = self->priv->headerbar;
#line 277 "../src/Application.vala"
	_tmp33_ = self->priv->navigation_button;
#line 277 "../src/Application.vala"
	gtk_header_bar_pack_start (_tmp32_, (GtkWidget*) _tmp33_);
#line 278 "../src/Application.vala"
	_tmp34_ = self->priv->headerbar;
#line 278 "../src/Application.vala"
	_tmp35_ = self->priv->_search_box;
#line 278 "../src/Application.vala"
	gtk_header_bar_pack_end (_tmp34_, (GtkWidget*) _tmp35_);
#line 280 "../src/Application.vala"
	_tmp36_ = switchboard_switchboard_app_plug_to_open;
#line 280 "../src/Application.vala"
	_tmp37_ = switchboard_category_view_new (_tmp36_);
#line 280 "../src/Application.vala"
	g_object_ref_sink (_tmp37_);
#line 280 "../src/Application.vala"
	_g_object_unref0 (self->category_view);
#line 280 "../src/Application.vala"
	self->category_view = _tmp37_;
#line 281 "../src/Application.vala"
	_tmp38_ = self->category_view;
#line 281 "../src/Application.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp38_, 12);
#line 282 "../src/Application.vala"
	_tmp39_ = self->category_view;
#line 282 "../src/Application.vala"
	g_signal_connect_object (_tmp39_, "plug-selected", (GCallback) ___lambda12__switchboard_category_view_plug_selected, self, 0);
#line 283 "../src/Application.vala"
	_tmp40_ = self->category_view;
#line 283 "../src/Application.vala"
	switchboard_category_view_load_default_plugs (_tmp40_, NULL, NULL);
#line 285 "../src/Application.vala"
	_tmp41_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 285 "../src/Application.vala"
	g_object_ref_sink (_tmp41_);
#line 285 "../src/Application.vala"
	_g_object_unref0 (self->priv->category_scrolled);
#line 285 "../src/Application.vala"
	self->priv->category_scrolled = _tmp41_;
#line 286 "../src/Application.vala"
	_tmp42_ = self->priv->category_scrolled;
#line 286 "../src/Application.vala"
	_tmp43_ = self->category_view;
#line 286 "../src/Application.vala"
	gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp43_);
#line 288 "../src/Application.vala"
	_tmp44_ = granite_widgets_alert_view_new ("", "", "");
#line 288 "../src/Application.vala"
	g_object_ref_sink (_tmp44_);
#line 288 "../src/Application.vala"
	_g_object_unref0 (self->priv->alert_view);
#line 288 "../src/Application.vala"
	self->priv->alert_view = _tmp44_;
#line 289 "../src/Application.vala"
	_tmp45_ = self->priv->alert_view;
#line 289 "../src/Application.vala"
	_tmp46_ = gtk_widget_get_style_context ((GtkWidget*) _tmp45_);
#line 289 "../src/Application.vala"
	gtk_style_context_add_class (_tmp46_, GTK_STYLE_CLASS_DIM_LABEL);
#line 291 "../src/Application.vala"
	_tmp47_ = (GtkStack*) gtk_stack_new ();
#line 291 "../src/Application.vala"
	g_object_ref_sink (_tmp47_);
#line 291 "../src/Application.vala"
	_g_object_unref0 (self->priv->stack);
#line 291 "../src/Application.vala"
	self->priv->stack = _tmp47_;
#line 292 "../src/Application.vala"
	_tmp48_ = self->priv->stack;
#line 292 "../src/Application.vala"
	gtk_stack_set_transition_type (_tmp48_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 293 "../src/Application.vala"
	_tmp49_ = self->priv->stack;
#line 293 "../src/Application.vala"
	_tmp50_ = self->priv->alert_view;
#line 293 "../src/Application.vala"
	gtk_stack_add_named (_tmp49_, (GtkWidget*) _tmp50_, "alert");
#line 294 "../src/Application.vala"
	_tmp51_ = self->priv->stack;
#line 294 "../src/Application.vala"
	_tmp52_ = self->priv->category_scrolled;
#line 294 "../src/Application.vala"
	gtk_stack_add_named (_tmp51_, (GtkWidget*) _tmp52_, "main");
#line 296 "../src/Application.vala"
	_tmp53_ = (GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL);
#line 296 "../src/Application.vala"
	g_object_ref_sink (_tmp53_);
#line 296 "../src/Application.vala"
	_g_object_unref0 (self->priv->main_window);
#line 296 "../src/Application.vala"
	self->priv->main_window = _tmp53_;
#line 297 "../src/Application.vala"
	_tmp54_ = self->priv->main_window;
#line 297 "../src/Application.vala"
	gtk_window_set_application (_tmp54_, (GtkApplication*) self);
#line 298 "../src/Application.vala"
	_tmp55_ = self->priv->main_window;
#line 298 "../src/Application.vala"
	gtk_window_set_icon_name (_tmp55_, "preferences-desktop");
#line 299 "../src/Application.vala"
	_tmp56_ = self->priv->main_window;
#line 299 "../src/Application.vala"
	gtk_window_set_title (_tmp56_, _ ("System Settings"));
#line 300 "../src/Application.vala"
	_tmp57_ = self->priv->main_window;
#line 300 "../src/Application.vala"
	_tmp58_ = self->priv->stack;
#line 300 "../src/Application.vala"
	gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp58_);
#line 301 "../src/Application.vala"
	_tmp59_ = self->priv->main_window;
#line 301 "../src/Application.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp59_, 910, 640);
#line 302 "../src/Application.vala"
	_tmp60_ = self->priv->main_window;
#line 302 "../src/Application.vala"
	_tmp61_ = self->priv->headerbar;
#line 302 "../src/Application.vala"
	gtk_window_set_titlebar (_tmp60_, (GtkWidget*) _tmp61_);
#line 305 "../src/Application.vala"
	memset (&_data2_->rect, 0, sizeof (GtkAllocation));
#line 307 "../src/Application.vala"
	_tmp62_ = g_settings_new ("io.elementary.switchboard.saved-state");
#line 307 "../src/Application.vala"
	_data2_->settings = _tmp62_;
#line 308 "../src/Application.vala"
	_tmp63_ = _data2_->settings;
#line 308 "../src/Application.vala"
	g_settings_get (_tmp63_, "window-position", "(ii)", &_tmp64_, &_tmp65_);
#line 308 "../src/Application.vala"
	window_x = _tmp64_;
#line 308 "../src/Application.vala"
	window_y = _tmp65_;
#line 309 "../src/Application.vala"
	_tmp66_ = _data2_->settings;
#line 309 "../src/Application.vala"
	g_settings_get (_tmp66_, "window-size", "(ii)", &_tmp67_, &_tmp68_);
#line 309 "../src/Application.vala"
	_data2_->rect.width = _tmp67_;
#line 309 "../src/Application.vala"
	_data2_->rect.height = _tmp68_;
#line 311 "../src/Application.vala"
	if (window_x != -1) {
#line 311 "../src/Application.vala"
		_tmp69_ = TRUE;
#line 2296 "Application.c"
	} else {
#line 311 "../src/Application.vala"
		_tmp69_ = window_y != -1;
#line 2300 "Application.c"
	}
#line 311 "../src/Application.vala"
	if (_tmp69_) {
#line 2304 "Application.c"
		GtkWindow* _tmp70_;
#line 312 "../src/Application.vala"
		_tmp70_ = self->priv->main_window;
#line 312 "../src/Application.vala"
		gtk_window_move (_tmp70_, window_x, window_y);
#line 2310 "Application.c"
	}
#line 315 "../src/Application.vala"
	_tmp71_ = self->priv->main_window;
#line 315 "../src/Application.vala"
	_tmp72_ = _data2_->rect;
#line 315 "../src/Application.vala"
	gtk_widget_set_allocation ((GtkWidget*) _tmp71_, &_tmp72_);
#line 317 "../src/Application.vala"
	_tmp73_ = _data2_->settings;
#line 317 "../src/Application.vala"
	if (g_settings_get_boolean (_tmp73_, "window-maximized")) {
#line 2322 "Application.c"
		GtkWindow* _tmp74_;
#line 318 "../src/Application.vala"
		_tmp74_ = self->priv->main_window;
#line 318 "../src/Application.vala"
		gtk_window_maximize (_tmp74_);
#line 2328 "Application.c"
	}
#line 321 "../src/Application.vala"
	_tmp75_ = self->priv->main_window;
#line 321 "../src/Application.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp75_);
#line 323 "../src/Application.vala"
	_tmp76_ = self->priv->navigation_button;
#line 323 "../src/Application.vala"
	gtk_widget_hide ((GtkWidget*) _tmp76_);
#line 325 "../src/Application.vala"
	_tmp77_ = self->priv->main_window;
#line 325 "../src/Application.vala"
	gtk_application_add_window ((GtkApplication*) self, _tmp77_);
#line 327 "../src/Application.vala"
	_tmp78_ = self->priv->_search_box;
#line 327 "../src/Application.vala"
	g_signal_connect_object ((GtkEditable*) _tmp78_, "changed", (GCallback) ___lambda13__gtk_editable_changed, self, 0);
#line 331 "../src/Application.vala"
	_tmp79_ = self->priv->_search_box;
#line 331 "../src/Application.vala"
	g_signal_connect_object ((GtkWidget*) _tmp79_, "key-press-event", (GCallback) ___lambda14__gtk_widget_key_press_event, self, 0);
#line 346 "../src/Application.vala"
	_tmp80_ = back_action;
#line 346 "../src/Application.vala"
	g_signal_connect_object (_tmp80_, "activate", (GCallback) ___lambda15__g_simple_action_activate, self, 0);
#line 350 "../src/Application.vala"
	_tmp81_ = quit_action;
#line 350 "../src/Application.vala"
	g_signal_connect_object (_tmp81_, "activate", (GCallback) ___lambda16__g_simple_action_activate, self, 0);
#line 354 "../src/Application.vala"
	_tmp82_ = self->priv->main_window;
#line 354 "../src/Application.vala"
	g_signal_connect_object ((GtkWidget*) _tmp82_, "button-release-event", (GCallback) ___lambda17__gtk_widget_button_release_event, self, 0);
#line 363 "../src/Application.vala"
	_tmp83_ = self->priv->main_window;
#line 363 "../src/Application.vala"
	g_signal_connect_object ((GtkWidget*) _tmp83_, "destroy", (GCallback) _switchboard_switchboard_app_shut_down_gtk_widget_destroy, self, 0);
#line 365 "../src/Application.vala"
	_tmp84_ = self->priv->main_window;
#line 365 "../src/Application.vala"
	g_signal_connect_data ((GtkWidget*) _tmp84_, "configure-event", (GCallback) ___lambda18__gtk_widget_configure_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 392 "../src/Application.vala"
	_tmp85_ = self->priv->main_window;
#line 392 "../src/Application.vala"
	g_signal_connect_object ((GtkWidget*) _tmp85_, "key-press-event", (GCallback) ___lambda20__gtk_widget_key_press_event, self, 0);
#line 410 "../src/Application.vala"
	_tmp86_ = self->priv->main_window;
#line 410 "../src/Application.vala"
	g_signal_connect_object ((GtkWidget*) _tmp86_, "size-allocate", (GCallback) ___lambda21__gtk_widget_size_allocate, self, 0);
#line 416 "../src/Application.vala"
	_tmp87_ = switchboard_plugs_manager_get_default ();
#line 416 "../src/Application.vala"
	_tmp88_ = _tmp87_;
#line 416 "../src/Application.vala"
	_tmp89_ = switchboard_plugs_manager_has_plugs (_tmp88_) == FALSE;
#line 416 "../src/Application.vala"
	_g_object_unref0 (_tmp88_);
#line 416 "../src/Application.vala"
	if (_tmp89_) {
#line 2388 "Application.c"
		GtkSearchEntry* _tmp90_;
#line 417 "../src/Application.vala"
		switchboard_switchboard_app_show_alert (self, _ ("No Settings Found"), _ ("Install some and re-launch Switchboard."), "dialog-warning");
#line 418 "../src/Application.vala"
		_tmp90_ = self->priv->_search_box;
#line 418 "../src/Application.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp90_, FALSE);
#line 2396 "Application.c"
	} else {
		GtkSearchEntry* _tmp91_;
		GtkSearchEntry* _tmp92_;
#line 420 "../src/Application.vala"
		_tmp91_ = self->priv->_search_box;
#line 420 "../src/Application.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp91_, TRUE);
#line 421 "../src/Application.vala"
		_tmp92_ = self->priv->_search_box;
#line 421 "../src/Application.vala"
		g_object_set ((GtkWidget*) _tmp92_, "has-focus", TRUE, NULL);
#line 2408 "Application.c"
	}
#line 252 "../src/Application.vala"
	_g_object_unref0 (quit_action);
#line 252 "../src/Application.vala"
	_g_object_unref0 (back_action);
#line 252 "../src/Application.vala"
	block2_data_unref (_data2_);
#line 252 "../src/Application.vala"
	_data2_ = NULL;
#line 2418 "Application.c"
}

static void
switchboard_switchboard_app_shut_down (SwitchboardSwitchboardApp* self)
{
	SwitchboardPlug* _tmp0_;
#line 428 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 429 "../src/Application.vala"
	_tmp0_ = self->current_plug;
#line 429 "../src/Application.vala"
	if (_tmp0_ != NULL) {
#line 2431 "Application.c"
		SwitchboardPlug* _tmp1_;
#line 430 "../src/Application.vala"
		_tmp1_ = self->current_plug;
#line 430 "../src/Application.vala"
		switchboard_plug_hidden (_tmp1_);
#line 2437 "Application.c"
	}
#line 433 "../src/Application.vala"
	gtk_main_quit ();
#line 2441 "Application.c"
}

static void
switchboard_switchboard_app_handle_navigation_button_clicked (SwitchboardSwitchboardApp* self)
{
	GtkButton* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 437 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 438 "../src/Application.vala"
	_tmp0_ = self->priv->navigation_button;
#line 438 "../src/Application.vala"
	_tmp1_ = gtk_button_get_label (_tmp0_);
#line 438 "../src/Application.vala"
	_tmp2_ = _tmp1_;
#line 438 "../src/Application.vala"
	_tmp3_ = self->priv->all_settings_label;
#line 438 "../src/Application.vala"
	if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
#line 2463 "Application.c"
		GtkSearchEntry* _tmp4_;
		GtkButton* _tmp5_;
#line 439 "../src/Application.vala"
		switchboard_switchboard_app_opened_directly = FALSE;
#line 440 "../src/Application.vala"
		_tmp4_ = self->priv->_search_box;
#line 440 "../src/Application.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
#line 441 "../src/Application.vala"
		switchboard_switchboard_app_switch_to_icons (self);
#line 442 "../src/Application.vala"
		_tmp5_ = self->priv->navigation_button;
#line 442 "../src/Application.vala"
		gtk_widget_hide ((GtkWidget*) _tmp5_);
#line 2478 "Application.c"
	} else {
		gboolean _tmp6_ = FALSE;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 444 "../src/Application.vala"
		_tmp7_ = self->previous_plugs;
#line 444 "../src/Application.vala"
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 444 "../src/Application.vala"
		_tmp9_ = _tmp8_;
#line 444 "../src/Application.vala"
		if (_tmp9_ > 0) {
#line 2492 "Application.c"
			GtkStack* _tmp10_;
			const gchar* _tmp11_;
#line 444 "../src/Application.vala"
			_tmp10_ = self->priv->stack;
#line 444 "../src/Application.vala"
			_tmp11_ = gtk_stack_get_visible_child_name (_tmp10_);
#line 444 "../src/Application.vala"
			_tmp6_ = g_strcmp0 (_tmp11_, "main") != 0;
#line 2501 "Application.c"
		} else {
#line 444 "../src/Application.vala"
			_tmp6_ = FALSE;
#line 2505 "Application.c"
		}
#line 444 "../src/Application.vala"
		if (_tmp6_) {
#line 2509 "Application.c"
			SwitchboardPlug* _tmp12_;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			SwitchboardPlug* _tmp16_;
			GeeArrayList* _tmp17_;
			gpointer _tmp18_;
			SwitchboardPlug* _tmp19_;
#line 445 "../src/Application.vala"
			_tmp12_ = self->current_plug;
#line 445 "../src/Application.vala"
			if (_tmp12_ != NULL) {
#line 2521 "Application.c"
				SwitchboardPlug* _tmp13_;
#line 446 "../src/Application.vala"
				_tmp13_ = self->current_plug;
#line 446 "../src/Application.vala"
				switchboard_plug_hidden (_tmp13_);
#line 2527 "Application.c"
			}
#line 449 "../src/Application.vala"
			_tmp14_ = self->previous_plugs;
#line 449 "../src/Application.vala"
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, 0);
#line 449 "../src/Application.vala"
			_tmp16_ = (SwitchboardPlug*) _tmp15_;
#line 449 "../src/Application.vala"
			switchboard_switchboard_app_load_plug (self, _tmp16_);
#line 449 "../src/Application.vala"
			_g_object_unref0 (_tmp16_);
#line 450 "../src/Application.vala"
			_tmp17_ = self->previous_plugs;
#line 450 "../src/Application.vala"
			_tmp18_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp17_, 0);
#line 450 "../src/Application.vala"
			_tmp19_ = (SwitchboardPlug*) _tmp18_;
#line 450 "../src/Application.vala"
			_g_object_unref0 (_tmp19_);
#line 2547 "Application.c"
		} else {
			SwitchboardPlug* _tmp20_;
#line 452 "../src/Application.vala"
			_tmp20_ = self->current_plug;
#line 452 "../src/Application.vala"
			switchboard_switchboard_app_switch_to_plug (self, _tmp20_);
#line 2554 "Application.c"
		}
	}
}

static gboolean
switchboard_switchboard_app_load_setting_path (SwitchboardSwitchboardApp* self,
                                               const gchar* setting_path,
                                               SwitchboardPlugsManager* plugsmanager)
{
	gboolean result = FALSE;
#line 458 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 458 "../src/Application.vala"
	g_return_val_if_fail (setting_path != NULL, FALSE);
#line 458 "../src/Application.vala"
	g_return_val_if_fail (plugsmanager != NULL, FALSE);
#line 2571 "Application.c"
	{
		GeeIterator* _plug_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 459 "../src/Application.vala"
		_tmp0_ = switchboard_plugs_manager_get_plugs (plugsmanager);
#line 459 "../src/Application.vala"
		_tmp1_ = _tmp0_;
#line 459 "../src/Application.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 459 "../src/Application.vala"
		_tmp3_ = _tmp2_;
#line 459 "../src/Application.vala"
		_g_object_unref0 (_tmp1_);
#line 459 "../src/Application.vala"
		_plug_it = _tmp3_;
#line 459 "../src/Application.vala"
		while (TRUE) {
#line 2592 "Application.c"
			GeeIterator* _tmp4_;
			SwitchboardPlug* plug = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			GeeTreeMap* supported_settings = NULL;
			SwitchboardPlug* _tmp7_;
			GeeTreeMap* _tmp8_;
			GeeTreeMap* _tmp9_;
			GeeTreeMap* _tmp10_;
			GeeTreeMap* _tmp11_;
			GeeTreeMap* _tmp12_;
#line 459 "../src/Application.vala"
			_tmp4_ = _plug_it;
#line 459 "../src/Application.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 459 "../src/Application.vala"
				break;
#line 2610 "Application.c"
			}
#line 459 "../src/Application.vala"
			_tmp5_ = _plug_it;
#line 459 "../src/Application.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 459 "../src/Application.vala"
			plug = (SwitchboardPlug*) _tmp6_;
#line 460 "../src/Application.vala"
			_tmp7_ = plug;
#line 460 "../src/Application.vala"
			_tmp8_ = switchboard_plug_get_supported_settings (_tmp7_);
#line 460 "../src/Application.vala"
			_tmp9_ = _tmp8_;
#line 460 "../src/Application.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 460 "../src/Application.vala"
			supported_settings = _tmp10_;
#line 461 "../src/Application.vala"
			_tmp11_ = supported_settings;
#line 461 "../src/Application.vala"
			if (_tmp11_ == NULL) {
#line 462 "../src/Application.vala"
				_g_object_unref0 (supported_settings);
#line 462 "../src/Application.vala"
				_g_object_unref0 (plug);
#line 462 "../src/Application.vala"
				continue;
#line 2638 "Application.c"
			}
#line 465 "../src/Application.vala"
			_tmp12_ = supported_settings;
#line 465 "../src/Application.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp12_, setting_path)) {
#line 2644 "Application.c"
				SwitchboardPlug* _tmp13_;
				SwitchboardPlug* _tmp15_;
				GeeTreeMap* _tmp16_;
				gpointer _tmp17_;
#line 466 "../src/Application.vala"
				_tmp13_ = self->current_plug;
#line 466 "../src/Application.vala"
				if (_tmp13_ != NULL) {
#line 2653 "Application.c"
					SwitchboardPlug* _tmp14_;
#line 467 "../src/Application.vala"
					_tmp14_ = self->current_plug;
#line 467 "../src/Application.vala"
					switchboard_plug_hidden (_tmp14_);
#line 2659 "Application.c"
				}
#line 470 "../src/Application.vala"
				_tmp15_ = plug;
#line 470 "../src/Application.vala"
				switchboard_switchboard_app_load_plug (self, _tmp15_);
#line 471 "../src/Application.vala"
				_tmp16_ = supported_settings;
#line 471 "../src/Application.vala"
				_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp16_, setting_path);
#line 471 "../src/Application.vala"
				_g_free0 (switchboard_switchboard_app_open_window);
#line 471 "../src/Application.vala"
				switchboard_switchboard_app_open_window = (gchar*) _tmp17_;
#line 472 "../src/Application.vala"
				result = TRUE;
#line 472 "../src/Application.vala"
				_g_object_unref0 (supported_settings);
#line 472 "../src/Application.vala"
				_g_object_unref0 (plug);
#line 472 "../src/Application.vala"
				_g_object_unref0 (_plug_it);
#line 472 "../src/Application.vala"
				return result;
#line 2683 "Application.c"
			}
#line 459 "../src/Application.vala"
			_g_object_unref0 (supported_settings);
#line 459 "../src/Application.vala"
			_g_object_unref0 (plug);
#line 2689 "Application.c"
		}
#line 459 "../src/Application.vala"
		_g_object_unref0 (_plug_it);
#line 2693 "Application.c"
	}
#line 477 "../src/Application.vala"
	if (string_contains (setting_path, "/")) {
#line 2697 "Application.c"
		gint last_index = 0;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gboolean _tmp20_;
#line 478 "../src/Application.vala"
		last_index = string_last_index_of_char (setting_path, (gunichar) '/', 0);
#line 479 "../src/Application.vala"
		_tmp18_ = string_substring (setting_path, (glong) 0, (glong) last_index);
#line 479 "../src/Application.vala"
		_tmp19_ = _tmp18_;
#line 479 "../src/Application.vala"
		_tmp20_ = switchboard_switchboard_app_load_setting_path (self, _tmp19_, plugsmanager);
#line 479 "../src/Application.vala"
		_g_free0 (_tmp19_);
#line 479 "../src/Application.vala"
		result = _tmp20_;
#line 479 "../src/Application.vala"
		return result;
#line 2716 "Application.c"
	}
#line 482 "../src/Application.vala"
	result = FALSE;
#line 482 "../src/Application.vala"
	return result;
#line 2722 "Application.c"
}

static void
switchboard_switchboard_app_switch_to_plug (SwitchboardSwitchboardApp* self,
                                            SwitchboardPlug* plug)
{
	gboolean _tmp5_ = FALSE;
	GeeArrayList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GtkSearchEntry* _tmp25_;
	GtkStack* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	GtkScrolledWindow* _tmp29_;
#line 486 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 486 "../src/Application.vala"
	g_return_if_fail (plug != NULL);
#line 487 "../src/Application.vala"
	if (switchboard_switchboard_app_should_animate_next_transition == FALSE) {
#line 2744 "Application.c"
		GtkStack* _tmp0_;
#line 488 "../src/Application.vala"
		_tmp0_ = self->priv->stack;
#line 488 "../src/Application.vala"
		gtk_stack_set_transition_type (_tmp0_, GTK_STACK_TRANSITION_TYPE_NONE);
#line 489 "../src/Application.vala"
		switchboard_switchboard_app_should_animate_next_transition = TRUE;
#line 2752 "Application.c"
	} else {
		GtkStack* _tmp1_;
		GtkStackTransitionType _tmp2_;
		GtkStackTransitionType _tmp3_;
#line 490 "../src/Application.vala"
		_tmp1_ = self->priv->stack;
#line 490 "../src/Application.vala"
		_tmp2_ = gtk_stack_get_transition_type (_tmp1_);
#line 490 "../src/Application.vala"
		_tmp3_ = _tmp2_;
#line 490 "../src/Application.vala"
		if (_tmp3_ == GTK_STACK_TRANSITION_TYPE_NONE) {
#line 2765 "Application.c"
			GtkStack* _tmp4_;
#line 491 "../src/Application.vala"
			_tmp4_ = self->priv->stack;
#line 491 "../src/Application.vala"
			gtk_stack_set_transition_type (_tmp4_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 2771 "Application.c"
		}
	}
#line 494 "../src/Application.vala"
	_tmp6_ = self->previous_plugs;
#line 494 "../src/Application.vala"
	_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 494 "../src/Application.vala"
	_tmp8_ = _tmp7_;
#line 494 "../src/Application.vala"
	if (_tmp8_ > 1) {
#line 2782 "Application.c"
		GtkStack* _tmp9_;
		const gchar* _tmp10_;
#line 494 "../src/Application.vala"
		_tmp9_ = self->priv->stack;
#line 494 "../src/Application.vala"
		_tmp10_ = gtk_stack_get_visible_child_name (_tmp9_);
#line 494 "../src/Application.vala"
		_tmp5_ = g_strcmp0 (_tmp10_, "main") != 0;
#line 2791 "Application.c"
	} else {
#line 494 "../src/Application.vala"
		_tmp5_ = FALSE;
#line 2795 "Application.c"
	}
#line 494 "../src/Application.vala"
	if (_tmp5_) {
#line 2799 "Application.c"
		GtkButton* _tmp11_;
		GeeArrayList* _tmp12_;
		gpointer _tmp13_;
		SwitchboardPlug* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		GeeArrayList* _tmp17_;
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gpointer _tmp21_;
		SwitchboardPlug* _tmp22_;
#line 495 "../src/Application.vala"
		_tmp11_ = self->priv->navigation_button;
#line 495 "../src/Application.vala"
		_tmp12_ = self->previous_plugs;
#line 495 "../src/Application.vala"
		_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, 0);
#line 495 "../src/Application.vala"
		_tmp14_ = (SwitchboardPlug*) _tmp13_;
#line 495 "../src/Application.vala"
		_tmp15_ = switchboard_plug_get_display_name (_tmp14_);
#line 495 "../src/Application.vala"
		_tmp16_ = _tmp15_;
#line 495 "../src/Application.vala"
		gtk_button_set_label (_tmp11_, _tmp16_);
#line 495 "../src/Application.vala"
		_g_object_unref0 (_tmp14_);
#line 496 "../src/Application.vala"
		_tmp17_ = self->previous_plugs;
#line 496 "../src/Application.vala"
		_tmp18_ = self->previous_plugs;
#line 496 "../src/Application.vala"
		_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 496 "../src/Application.vala"
		_tmp20_ = _tmp19_;
#line 496 "../src/Application.vala"
		_tmp21_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp17_, _tmp20_ - 1);
#line 496 "../src/Application.vala"
		_tmp22_ = (SwitchboardPlug*) _tmp21_;
#line 496 "../src/Application.vala"
		_g_object_unref0 (_tmp22_);
#line 2842 "Application.c"
	} else {
		GtkButton* _tmp23_;
		const gchar* _tmp24_;
#line 498 "../src/Application.vala"
		_tmp23_ = self->priv->navigation_button;
#line 498 "../src/Application.vala"
		_tmp24_ = self->priv->all_settings_label;
#line 498 "../src/Application.vala"
		gtk_button_set_label (_tmp23_, _tmp24_);
#line 2852 "Application.c"
	}
#line 501 "../src/Application.vala"
	_tmp25_ = self->priv->_search_box;
#line 501 "../src/Application.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, FALSE);
#line 502 "../src/Application.vala"
	switchboard_plug_shown (plug);
#line 503 "../src/Application.vala"
	_tmp26_ = self->priv->stack;
#line 503 "../src/Application.vala"
	_tmp27_ = switchboard_plug_get_code_name (plug);
#line 503 "../src/Application.vala"
	_tmp28_ = _tmp27_;
#line 503 "../src/Application.vala"
	gtk_stack_set_visible_child_name (_tmp26_, _tmp28_);
#line 504 "../src/Application.vala"
	_tmp29_ = self->priv->category_scrolled;
#line 504 "../src/Application.vala"
	gtk_widget_hide ((GtkWidget*) _tmp29_);
#line 2872 "Application.c"
}

static gboolean
switchboard_switchboard_app_switch_to_icons (SwitchboardSwitchboardApp* self)
{
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	GtkScrolledWindow* _tmp1_;
	GtkStack* _tmp2_;
	SwitchboardPlug* _tmp3_;
	GtkHeaderBar* _tmp4_;
	GtkSearchEntry* _tmp5_;
	GtkSearchEntry* _tmp6_;
	SwitchboardPlugsManager* _tmp7_;
	SwitchboardPlugsManager* _tmp8_;
	GtkSearchEntry* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
#line 507 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 508 "../src/Application.vala"
	_tmp0_ = self->previous_plugs;
#line 508 "../src/Application.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 509 "../src/Application.vala"
	_tmp1_ = self->priv->category_scrolled;
#line 509 "../src/Application.vala"
	gtk_widget_show ((GtkWidget*) _tmp1_);
#line 510 "../src/Application.vala"
	_tmp2_ = self->priv->stack;
#line 510 "../src/Application.vala"
	gtk_stack_set_visible_child_full (_tmp2_, "main", GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
#line 511 "../src/Application.vala"
	_tmp3_ = self->current_plug;
#line 511 "../src/Application.vala"
	switchboard_plug_hidden (_tmp3_);
#line 513 "../src/Application.vala"
	_tmp4_ = self->priv->headerbar;
#line 513 "../src/Application.vala"
	gtk_header_bar_set_title (_tmp4_, _ ("System Settings"));
#line 515 "../src/Application.vala"
	_tmp5_ = self->priv->_search_box;
#line 515 "../src/Application.vala"
	gtk_entry_set_text ((GtkEntry*) _tmp5_, "");
#line 516 "../src/Application.vala"
	_tmp6_ = self->priv->_search_box;
#line 516 "../src/Application.vala"
	_tmp7_ = switchboard_plugs_manager_get_default ();
#line 516 "../src/Application.vala"
	_tmp8_ = _tmp7_;
#line 516 "../src/Application.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, switchboard_plugs_manager_has_plugs (_tmp8_));
#line 516 "../src/Application.vala"
	_g_object_unref0 (_tmp8_);
#line 518 "../src/Application.vala"
	_tmp9_ = self->priv->_search_box;
#line 518 "../src/Application.vala"
	_tmp10_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp9_);
#line 518 "../src/Application.vala"
	_tmp11_ = _tmp10_;
#line 518 "../src/Application.vala"
	if (_tmp11_) {
#line 2935 "Application.c"
		GtkSearchEntry* _tmp12_;
#line 519 "../src/Application.vala"
		_tmp12_ = self->priv->_search_box;
#line 519 "../src/Application.vala"
		g_object_set ((GtkWidget*) _tmp12_, "has-focus", TRUE, NULL);
#line 2941 "Application.c"
	}
#line 522 "../src/Application.vala"
	result = TRUE;
#line 522 "../src/Application.vala"
	return result;
#line 2947 "Application.c"
}

static gchar*
switchboard_switchboard_app_gcc_to_switchboard_code_name (SwitchboardSwitchboardApp* self,
                                                          const gchar* gcc_name)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label0 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label1 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label2 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label3 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label4 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label5 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label6 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label7 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label8 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label9 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label10 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label11 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label12 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label13 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label14 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label15 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label16 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label17 = 0;
#line 572 "../src/Application.vala"
	static GQuark _tmp1_label18 = 0;
#line 570 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 570 "../src/Application.vala"
	g_return_val_if_fail (gcc_name != NULL, NULL);
#line 572 "../src/Application.vala"
	_tmp0_ = gcc_name;
#line 572 "../src/Application.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 572 "../src/Application.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("background")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3007 "Application.c"
			default:
			{
				gchar* _tmp3_;
#line 573 "../src/Application.vala"
				_tmp3_ = g_strdup ("pantheon-desktop");
#line 573 "../src/Application.vala"
				result = _tmp3_;
#line 573 "../src/Application.vala"
				return result;
#line 3017 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("bluetooth")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3023 "Application.c"
			default:
			{
				gchar* _tmp4_;
#line 574 "../src/Application.vala"
				_tmp4_ = g_strdup ("network-pantheon-bluetooth");
#line 574 "../src/Application.vala"
				result = _tmp4_;
#line 574 "../src/Application.vala"
				return result;
#line 3033 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("color")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3039 "Application.c"
			default:
			{
				gchar* _tmp5_;
#line 575 "../src/Application.vala"
				_tmp5_ = g_strdup ("hardware-gcc-color");
#line 575 "../src/Application.vala"
				result = _tmp5_;
#line 575 "../src/Application.vala"
				return result;
#line 3049 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("datetime")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3055 "Application.c"
			default:
			{
				gchar* _tmp6_;
#line 576 "../src/Application.vala"
				_tmp6_ = g_strdup ("system-pantheon-datetime");
#line 576 "../src/Application.vala"
				result = _tmp6_;
#line 576 "../src/Application.vala"
				return result;
#line 3065 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("display")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3071 "Application.c"
			default:
			{
				gchar* _tmp7_;
#line 577 "../src/Application.vala"
				_tmp7_ = g_strdup ("system-pantheon-display");
#line 577 "../src/Application.vala"
				result = _tmp7_;
#line 577 "../src/Application.vala"
				return result;
#line 3081 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("info")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3087 "Application.c"
			default:
			{
				gchar* _tmp8_;
#line 578 "../src/Application.vala"
				_tmp8_ = g_strdup ("system-pantheon-about");
#line 578 "../src/Application.vala"
				result = _tmp8_;
#line 578 "../src/Application.vala"
				return result;
#line 3097 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("keyboard")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3103 "Application.c"
			default:
			{
				gchar* _tmp9_;
#line 579 "../src/Application.vala"
				_tmp9_ = g_strdup ("hardware-pantheon-keyboard");
#line 579 "../src/Application.vala"
				result = _tmp9_;
#line 579 "../src/Application.vala"
				return result;
#line 3113 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("network")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3119 "Application.c"
			default:
			{
				gchar* _tmp10_;
#line 580 "../src/Application.vala"
				_tmp10_ = g_strdup ("pantheon-network");
#line 580 "../src/Application.vala"
				result = _tmp10_;
#line 580 "../src/Application.vala"
				return result;
#line 3129 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label8) ? _tmp1_label8 : (_tmp1_label8 = g_quark_from_static_string ("power")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3135 "Application.c"
			default:
			{
				gchar* _tmp11_;
#line 581 "../src/Application.vala"
				_tmp11_ = g_strdup ("system-pantheon-power");
#line 581 "../src/Application.vala"
				result = _tmp11_;
#line 581 "../src/Application.vala"
				return result;
#line 3145 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label9) ? _tmp1_label9 : (_tmp1_label9 = g_quark_from_static_string ("printers")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3151 "Application.c"
			default:
			{
				gchar* _tmp12_;
#line 582 "../src/Application.vala"
				_tmp12_ = g_strdup ("pantheon-printers");
#line 582 "../src/Application.vala"
				result = _tmp12_;
#line 582 "../src/Application.vala"
				return result;
#line 3161 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label10) ? _tmp1_label10 : (_tmp1_label10 = g_quark_from_static_string ("privacy")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3167 "Application.c"
			default:
			{
				gchar* _tmp13_;
#line 583 "../src/Application.vala"
				_tmp13_ = g_strdup ("pantheon-security-privacy");
#line 583 "../src/Application.vala"
				result = _tmp13_;
#line 583 "../src/Application.vala"
				return result;
#line 3177 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label11) ? _tmp1_label11 : (_tmp1_label11 = g_quark_from_static_string ("region")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3183 "Application.c"
			default:
			{
				gchar* _tmp14_;
#line 584 "../src/Application.vala"
				_tmp14_ = g_strdup ("system-pantheon-locale");
#line 584 "../src/Application.vala"
				result = _tmp14_;
#line 584 "../src/Application.vala"
				return result;
#line 3193 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label12) ? _tmp1_label12 : (_tmp1_label12 = g_quark_from_static_string ("sharing")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3199 "Application.c"
			default:
			{
				gchar* _tmp15_;
#line 585 "../src/Application.vala"
				_tmp15_ = g_strdup ("pantheon-sharing");
#line 585 "../src/Application.vala"
				result = _tmp15_;
#line 585 "../src/Application.vala"
				return result;
#line 3209 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label13) ? _tmp1_label13 : (_tmp1_label13 = g_quark_from_static_string ("sound")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3215 "Application.c"
			default:
			{
				gchar* _tmp16_;
#line 586 "../src/Application.vala"
				_tmp16_ = g_strdup ("hardware-gcc-sound");
#line 586 "../src/Application.vala"
				result = _tmp16_;
#line 586 "../src/Application.vala"
				return result;
#line 3225 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label14) ? _tmp1_label14 : (_tmp1_label14 = g_quark_from_static_string ("universal-access")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3231 "Application.c"
			default:
			{
				gchar* _tmp17_;
#line 587 "../src/Application.vala"
				_tmp17_ = g_strdup ("pantheon-accessibility");
#line 587 "../src/Application.vala"
				result = _tmp17_;
#line 587 "../src/Application.vala"
				return result;
#line 3241 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label15) ? _tmp1_label15 : (_tmp1_label15 = g_quark_from_static_string ("user-accounts")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3247 "Application.c"
			default:
			{
				gchar* _tmp18_;
#line 588 "../src/Application.vala"
				_tmp18_ = g_strdup ("system-pantheon-useraccounts");
#line 588 "../src/Application.vala"
				result = _tmp18_;
#line 588 "../src/Application.vala"
				return result;
#line 3257 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label16) ? _tmp1_label16 : (_tmp1_label16 = g_quark_from_static_string ("wacom")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3263 "Application.c"
			default:
			{
				gchar* _tmp19_;
#line 589 "../src/Application.vala"
				_tmp19_ = g_strdup ("hardware-gcc-wacom");
#line 589 "../src/Application.vala"
				result = _tmp19_;
#line 589 "../src/Application.vala"
				return result;
#line 3273 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label17) ? _tmp1_label17 : (_tmp1_label17 = g_quark_from_static_string ("notifications")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3279 "Application.c"
			default:
			{
				gchar* _tmp20_;
#line 590 "../src/Application.vala"
				_tmp20_ = g_strdup ("personal-pantheon-notifications");
#line 590 "../src/Application.vala"
				result = _tmp20_;
#line 590 "../src/Application.vala"
				return result;
#line 3289 "Application.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label18) ? _tmp1_label18 : (_tmp1_label18 = g_quark_from_static_string ("search")))) {
#line 572 "../src/Application.vala"
		switch (0) {
#line 3295 "Application.c"
			default:
			{
#line 594 "../src/Application.vala"
				result = NULL;
#line 594 "../src/Application.vala"
				return result;
#line 3302 "Application.c"
			}
		}
	}
#line 597 "../src/Application.vala"
	result = NULL;
#line 597 "../src/Application.vala"
	return result;
#line 3310 "Application.c"
}

SwitchboardSwitchboardApp*
switchboard_switchboard_app_construct (GType object_type)
{
	SwitchboardSwitchboardApp * self = NULL;
#line 32 "../src/Application.vala"
	self = (SwitchboardSwitchboardApp*) g_object_new (object_type, NULL);
#line 32 "../src/Application.vala"
	return self;
#line 3321 "Application.c"
}

SwitchboardSwitchboardApp*
switchboard_switchboard_app_new (void)
{
#line 32 "../src/Application.vala"
	return switchboard_switchboard_app_construct (SWITCHBOARD_TYPE_SWITCHBOARD_APP);
#line 3329 "Application.c"
}

GtkSearchEntry*
switchboard_switchboard_app_get_search_box (SwitchboardSwitchboardApp* self)
{
	GtkSearchEntry* result;
	GtkSearchEntry* _tmp0_;
#line 48 "../src/Application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/Application.vala"
	_tmp0_ = self->priv->_search_box;
#line 48 "../src/Application.vala"
	result = _tmp0_;
#line 48 "../src/Application.vala"
	return result;
#line 3345 "Application.c"
}

static void
switchboard_switchboard_app_set_search_box (SwitchboardSwitchboardApp* self,
                                            GtkSearchEntry* value)
{
#line 48 "../src/Application.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/Application.vala"
	if (switchboard_switchboard_app_get_search_box (self) != value) {
#line 3356 "Application.c"
		GtkSearchEntry* _tmp0_;
#line 48 "../src/Application.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 48 "../src/Application.vala"
		_g_object_unref0 (self->priv->_search_box);
#line 48 "../src/Application.vala"
		self->priv->_search_box = _tmp0_;
#line 48 "../src/Application.vala"
		g_object_notify_by_pspec ((GObject *) self, switchboard_switchboard_app_properties[SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY]);
#line 3366 "Application.c"
	}
}

SwitchboardSwitchboardApp*
switchboard_switchboard_app_get_instance (void)
{
	SwitchboardSwitchboardApp* result;
	SwitchboardSwitchboardApp* _tmp0_;
	SwitchboardSwitchboardApp* _tmp2_;
#line 80 "../src/Application.vala"
	_tmp0_ = switchboard_switchboard_app__instance;
#line 80 "../src/Application.vala"
	if (_tmp0_ == NULL) {
#line 3380 "Application.c"
		SwitchboardSwitchboardApp* _tmp1_;
#line 81 "../src/Application.vala"
		_tmp1_ = switchboard_switchboard_app_new ();
#line 81 "../src/Application.vala"
		_g_object_unref0 (switchboard_switchboard_app__instance);
#line 81 "../src/Application.vala"
		switchboard_switchboard_app__instance = _tmp1_;
#line 3388 "Application.c"
	}
#line 83 "../src/Application.vala"
	_tmp2_ = switchboard_switchboard_app__instance;
#line 83 "../src/Application.vala"
	result = _tmp2_;
#line 83 "../src/Application.vala"
	return result;
#line 3396 "Application.c"
}

static GObject *
switchboard_switchboard_app_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SwitchboardSwitchboardApp * self;
	GApplicationFlags _tmp0_;
	GApplicationFlags _tmp1_;
	GAppInfo* _tmp2_;
	GAppInfo* _tmp3_;
	gboolean _tmp4_;
	GError* _inner_error0_ = NULL;
#line 63 "../src/Application.vala"
	parent_class = G_OBJECT_CLASS (switchboard_switchboard_app_parent_class);
#line 63 "../src/Application.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 63 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
#line 64 "../src/Application.vala"
	g_application_set_application_id ((GApplication*) self, "io.elementary.switchboard");
#line 65 "../src/Application.vala"
	_tmp0_ = g_application_get_flags ((GApplication*) self);
#line 65 "../src/Application.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/Application.vala"
	g_application_set_flags ((GApplication*) self, _tmp1_ | G_APPLICATION_HANDLES_OPEN);
#line 67 "../src/Application.vala"
	_tmp2_ = g_app_info_get_default_for_uri_scheme ("settings");
#line 67 "../src/Application.vala"
	_tmp3_ = _tmp2_;
#line 67 "../src/Application.vala"
	_tmp4_ = _tmp3_ == NULL;
#line 67 "../src/Application.vala"
	_g_object_unref0 (_tmp3_);
#line 67 "../src/Application.vala"
	if (_tmp4_) {
#line 3437 "Application.c"
		GDesktopAppInfo* appinfo = NULL;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GDesktopAppInfo* _tmp9_;
		GDesktopAppInfo* _tmp10_;
#line 68 "../src/Application.vala"
		_tmp5_ = g_application_get_application_id ((GApplication*) self);
#line 68 "../src/Application.vala"
		_tmp6_ = _tmp5_;
#line 68 "../src/Application.vala"
		_tmp7_ = g_strconcat (_tmp6_, ".desktop", NULL);
#line 68 "../src/Application.vala"
		_tmp8_ = _tmp7_;
#line 68 "../src/Application.vala"
		_tmp9_ = g_desktop_app_info_new (_tmp8_);
#line 68 "../src/Application.vala"
		_tmp10_ = _tmp9_;
#line 68 "../src/Application.vala"
		_g_free0 (_tmp8_);
#line 68 "../src/Application.vala"
		appinfo = _tmp10_;
#line 3461 "Application.c"
		{
			GDesktopAppInfo* _tmp11_;
#line 70 "../src/Application.vala"
			_tmp11_ = appinfo;
#line 70 "../src/Application.vala"
			g_app_info_set_as_default_for_type ((GAppInfo*) _tmp11_, "x-scheme-handler/settings", &_inner_error0_);
#line 70 "../src/Application.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3470 "Application.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp12_;
			const gchar* _tmp13_;
#line 69 "../src/Application.vala"
			e = _inner_error0_;
#line 69 "../src/Application.vala"
			_inner_error0_ = NULL;
#line 72 "../src/Application.vala"
			_tmp12_ = e;
#line 72 "../src/Application.vala"
			_tmp13_ = _tmp12_->message;
#line 72 "../src/Application.vala"
			g_critical ("Application.vala:72: Unable to set default for the settings scheme: %s", _tmp13_);
#line 69 "../src/Application.vala"
			_g_error_free0 (e);
#line 3492 "Application.c"
		}
		__finally1:
#line 69 "../src/Application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/Application.vala"
			_g_object_unref0 (appinfo);
#line 69 "../src/Application.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "../src/Application.vala"
			g_clear_error (&_inner_error0_);
#line 3503 "Application.c"
		}
#line 67 "../src/Application.vala"
		_g_object_unref0 (appinfo);
#line 3507 "Application.c"
	}
#line 63 "../src/Application.vala"
	return obj;
#line 3511 "Application.c"
}

static void
switchboard_switchboard_app_class_init (SwitchboardSwitchboardAppClass * klass,
                                        gpointer klass_data)
{
#line 32 "../src/Application.vala"
	switchboard_switchboard_app_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/Application.vala"
	g_type_class_adjust_private_offset (klass, &SwitchboardSwitchboardApp_private_offset);
#line 32 "../src/Application.vala"
	((GApplicationClass *) klass)->open = (void (*) (GApplication*, GFile**, gint, const gchar*)) switchboard_switchboard_app_real_open;
#line 32 "../src/Application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) switchboard_switchboard_app_real_activate;
#line 32 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_switchboard_switchboard_app_get_property;
#line 32 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_switchboard_switchboard_app_set_property;
#line 32 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->constructor = switchboard_switchboard_app_constructor;
#line 32 "../src/Application.vala"
	G_OBJECT_CLASS (klass)->finalize = switchboard_switchboard_app_finalize;
#line 32 "../src/Application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY, switchboard_switchboard_app_properties[SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY] = g_param_spec_object ("search-box", "search-box", "search-box", gtk_search_entry_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3536 "Application.c"
}

static void
switchboard_switchboard_app_instance_init (SwitchboardSwitchboardApp * self,
                                           gpointer klass)
{
	gchar* _tmp0_;
#line 32 "../src/Application.vala"
	self->priv = switchboard_switchboard_app_get_instance_private (self);
#line 43 "../src/Application.vala"
	_tmp0_ = g_strdup (_ ("All Settings"));
#line 43 "../src/Application.vala"
	self->priv->all_settings_label = _tmp0_;
#line 3550 "Application.c"
}

static void
switchboard_switchboard_app_finalize (GObject * obj)
{
	SwitchboardSwitchboardApp * self;
#line 32 "../src/Application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
#line 33 "../src/Application.vala"
	_g_object_unref0 (self->priv->main_window);
#line 34 "../src/Application.vala"
	_g_object_unref0 (self->priv->category_scrolled);
#line 35 "../src/Application.vala"
	_g_object_unref0 (self->priv->stack);
#line 36 "../src/Application.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 38 "../src/Application.vala"
	_g_object_unref0 (self->priv->alert_view);
#line 39 "../src/Application.vala"
	_g_object_unref0 (self->priv->navigation_button);
#line 40 "../src/Application.vala"
	_g_object_unref0 (self->category_view);
#line 42 "../src/Application.vala"
	_g_object_unref0 (self->priv->loaded_plugs);
#line 43 "../src/Application.vala"
	_g_free0 (self->priv->all_settings_label);
#line 46 "../src/Application.vala"
	_g_object_unref0 (self->previous_plugs);
#line 47 "../src/Application.vala"
	_g_object_unref0 (self->current_plug);
#line 48 "../src/Application.vala"
	_g_object_unref0 (self->priv->_search_box);
#line 32 "../src/Application.vala"
	G_OBJECT_CLASS (switchboard_switchboard_app_parent_class)->finalize (obj);
#line 3585 "Application.c"
}

GType
switchboard_switchboard_app_get_type (void)
{
	static volatile gsize switchboard_switchboard_app_type_id__volatile = 0;
	if (g_once_init_enter (&switchboard_switchboard_app_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SwitchboardSwitchboardAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) switchboard_switchboard_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SwitchboardSwitchboardApp), 0, (GInstanceInitFunc) switchboard_switchboard_app_instance_init, NULL };
		GType switchboard_switchboard_app_type_id;
		switchboard_switchboard_app_type_id = g_type_register_static (gtk_application_get_type (), "SwitchboardSwitchboardApp", &g_define_type_info, 0);
		SwitchboardSwitchboardApp_private_offset = g_type_add_instance_private (switchboard_switchboard_app_type_id, sizeof (SwitchboardSwitchboardAppPrivate));
		g_once_init_leave (&switchboard_switchboard_app_type_id__volatile, switchboard_switchboard_app_type_id);
	}
	return switchboard_switchboard_app_type_id__volatile;
}

static void
_vala_switchboard_switchboard_app_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	SwitchboardSwitchboardApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
#line 32 "../src/Application.vala"
	switch (property_id) {
#line 32 "../src/Application.vala"
		case SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY:
#line 32 "../src/Application.vala"
		g_value_set_object (value, switchboard_switchboard_app_get_search_box (self));
#line 32 "../src/Application.vala"
		break;
#line 3618 "Application.c"
		default:
#line 32 "../src/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/Application.vala"
		break;
#line 3624 "Application.c"
	}
}

static void
_vala_switchboard_switchboard_app_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	SwitchboardSwitchboardApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SWITCHBOARD_TYPE_SWITCHBOARD_APP, SwitchboardSwitchboardApp);
#line 32 "../src/Application.vala"
	switch (property_id) {
#line 32 "../src/Application.vala"
		case SWITCHBOARD_SWITCHBOARD_APP_SEARCH_BOX_PROPERTY:
#line 32 "../src/Application.vala"
		switchboard_switchboard_app_set_search_box (self, g_value_get_object (value));
#line 32 "../src/Application.vala"
		break;
#line 3644 "Application.c"
		default:
#line 32 "../src/Application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "../src/Application.vala"
		break;
#line 3650 "Application.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

